Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes

# NodePath Class Reference

NodePath is the fundamental system for disambiguating instances, and also provides a higher-level interface for manipulating the scene graph. More...

List of all members.

## Public Types
enum | ErrorType { ETOk = 0, ETNotFound = 1, ETRemoved = 2, ETFail = 3 }
## Public Member Functions
| NodePath ()
| This constructs an empty NodePath with no nodes.
| NodePath (NodePath const copy)
| NodePath (NodePath const parent, PandaNode child_node)
| Constructs a NodePath with the indicated parent NodePath and child node; the child node must be a stashed or unstashed child of the parent.
| NodePath (string top_node_name)
| This constructs a new NodePath with a single node.
| NodePath (PandaNode node, Thread current_thread)
| This constructs a NodePath for the indicated node.
| NodePath (NodePath const parent, PandaNode child_node, Thread current_thread)
| Constructs a NodePath with the indicated parent NodePath and child node; the child node must be a stashed or unstashed child of the parent.
| NodePath (PandaNode node)
| This constructs a NodePath for the indicated node.
| NodePath (string top_node_name, Thread current_thread)
| This constructs a new NodePath with a single node.
unsigned int | addHash (unsigned int hash)
| Adds the NodePath into the running hash.
| adjustAllPriorities (int adjustment)
| Adds the indicated adjustment amount (which may be negative) to the priority for all transitions on the referenced node, and for all nodes in the subgraph below.
| applyTextureColors ()
| Removes textures from Geoms at this node and below by applying the texture colors to the vertices.
NodePath | attachNewNode (PandaNode node, int sort)
| Attaches a new node, with or without existing parents, to the scene graph below the referenced node of this NodePath.
NodePath | attachNewNode (PandaNode node, int sort, Thread current_thread)
| Attaches a new node, with or without existing parents, to the scene graph below the referenced node of this NodePath.
NodePath | attachNewNode (PandaNode node)
| Attaches a new node, with or without existing parents, to the scene graph below the referenced node of this NodePath.
NodePath | attachNewNode (string name, int sort, Thread current_thread)
| Creates an ordinary PandaNode and attaches it below the current NodePath, returning a new NodePath that references it.
NodePath | attachNewNode (string name, int sort)
| Creates an ordinary PandaNode and attaches it below the current NodePath, returning a new NodePath that references it.
NodePath | attachNewNode (string name)
| Creates an ordinary PandaNode and attaches it below the current NodePath, returning a new NodePath that references it.
bool | calcTightBounds (Point3 min_point, Point3 max_point, Thread current_thread)
| Calculates the minimum and maximum vertices of all Geoms at this NodePath's bottom node and below.
bool | calcTightBounds (Point3 min_point, Point3 max_point)
| Calculates the minimum and maximum vertices of all Geoms at this NodePath's bottom node and below.
| clearAntialias ()
| Completely removes any antialias setting that may have been set on this node via set_antialias().
| clearAttrib (TypeHandle type)
| Removes the render attribute of the given type from this node.
| clearAudioVolume ()
| Completely removes any audio volume from the referenced node.
| clearBillboard ()
| Removes any billboard effect from the node.
| clearBin ()
| Completely removes any bin adjustment that may have been set via set_bin() from this particular node.
| clearClipPlane (NodePath const clip_plane)
| Removes any reference to the indicated clipping plane from the NodePath.
| clearClipPlane ()
| Completely removes any clip planes that may have been set via set_clip_plane() or set_clip_plane_off() from this particular node.
| clearColor ()
| Completely removes any color adjustment from the node.
| clearColorScale ()
| Completely removes any color scale from the referenced node.
| clearCompass ()
| Removes any compass effect from the node.
| clearDepthOffset ()
| Completely removes any depth-offset adjustment that may have been set on this node via set_depth_offset().
| clearDepthTest ()
| Completely removes any depth-test adjustment that may have been set on this node via set_depth_test().
| clearDepthWrite ()
| Completely removes any depth-write adjustment that may have been set on this node via set_depth_write().
| clearEffect (TypeHandle type)
| Removes the render effect of the given type from this node.
| clearEffects ()
| Resets this node to have no render effects.
| clearFog ()
| Completely removes any fog adjustment that may have been set via set_fog() or set_fog_off() from this particular node.
| clearLight ()
| Completely removes any lighting operations that may have been set via set_light() or set_light_off() from this particular node.
| clearLight (NodePath const light)
| Removes any reference to the indicated Light or PolylightNode from the NodePath.
| clearMat ()
| Completely removes any transform from the referenced node.
| clearMaterial ()
| Completely removes any material adjustment that may have been set via set_material() from this particular node.
int | clearModelNodes ()
| Recursively walks through the scene graph at this level and below, looking for ModelNodes, and calls model_node->set_preserve_transform(PT_drop_node) on each one.
| clearNormalMap ()
| Undoes the effect of a previous call to set_normal_map().
| clearOccluder ()
| Completely removes any occluders that may have been set via set_occluder() from this particular node.
| clearOccluder (NodePath const occluder)
| Removes any reference to the indicated occluder from the NodePath.
| clearProjectTexture (TextureStage stage)
| Undoes the effect of project_texture().
| clearPythonTag (string key)
| Removes the Python object defined for this key on this particular node.
| clearRenderMode ()
| Completely removes any render mode adjustment that may have been set on this node via set_render_mode_wireframe() or set_render_mode_filled().
| clearScissor ()
| Removes the scissor region that was defined at this node level by a previous call to set_scissor().
| clearShader ()
| clearShaderInput (InternalName const id)
| clearShaderInput (string id)
| clearTag (string key)
| Removes the value defined for this key on this particular node.
| clearTexGen ()
| Removes the texture coordinate generation mode from all texture stages on this node.
| clearTexGen (TextureStage stage)
| Disables automatic texture coordinate generation for the indicated texture stage.
| clearTexProjector ()
| Removes the TexProjectorEffect for all stages from this node.
| clearTexProjector (TextureStage stage)
| Removes the TexProjectorEffect for the indicated stage from this node.
| clearTexTransform ()
| Removes all texture matrices from the current node.
| clearTexTransform (TextureStage stage)
| Removes the texture matrix on the current node for the given stage.
| clearTexture (TextureStage stage)
| Removes any reference to the indicated texture stage from the NodePath.
| clearTexture ()
| Completely removes any texture adjustment that may have been set via set_texture() or set_texture_off() from this particular node.
| clearTransform (NodePath const other, Thread current_thread)
| Sets the transform object on this node to identity, relative to the other node.
| clearTransform (NodePath const other)
| Sets the transform object on this node to identity, relative to the other node.
| clearTransform (Thread current_thread)
| Sets the transform object on this node to identity.
| clearTransform ()
| Sets the transform object on this node to identity.
| clearTransparency ()
| Completely removes any transparency adjustment that may have been set on this node via set_transparency().
| clearTwoSided ()
| Completely removes any two-sided adjustment that may have been set on this node via set_two_sided().
int | compareTo (NodePath const other)
| Returns a number less than zero if this NodePath sorts before the other one, greater than zero if it sorts after, or zero if they are equivalent.
| composeColorScale (VBase4 const scale, int priority)
| multiplies the color scale component of the transform, with previous color scale leaving translation and rotation untouched.
| composeColorScale (VBase4 const scale)
| multiplies the color scale component of the transform, with previous color scale leaving translation and rotation untouched.
| composeColorScale (float sx, float sy, float sz, float sa, int priority)
| Sets the color scale component of the transform.
| composeColorScale (float sx, float sy, float sz, float sa)
| Sets the color scale component of the transform.
NodePath | copy ()
| A special Python method that is invoked by copy.copy(node).
NodePath | copyTo (NodePath const other, int sort, Thread current_thread)
| Functions like instance_to(), except a deep copy is made of the referenced node and all of its descendents, which is then parented to the indicated node.
NodePath | copyTo (NodePath const other, int sort)
| Functions like instance_to(), except a deep copy is made of the referenced node and all of its descendents, which is then parented to the indicated node.
NodePath | copyTo (NodePath const other)
| Functions like instance_to(), except a deep copy is made of the referenced node and all of its descendents, which is then parented to the indicated node.
int | countNumDescendants ()
| Returns the number of nodes at and below this level.
PyObject | deepcopy (PyObject self, PyObject memo)
| A special Python method that is invoked by copy.deepcopy(np).
| detachNode (Thread current_thread)
| Disconnects the referenced node from its parent, but does not immediately delete it.
| detachNode ()
| Disconnects the referenced node from its parent, but does not immediately delete it.
| doBillboardAxis (NodePath const camera, float offset)
| Performs a billboard-type rotate to the indicated camera node, one time only, and leaves the object rotated.
| doBillboardPointEye (NodePath const camera, float offset)
| Performs a billboard-type rotate to the indicated camera node, one time only, and leaves the object rotated.
| doBillboardPointWorld (NodePath const camera, float offset)
| Performs a billboard-type rotate to the indicated camera node, one time only, and leaves the object rotated.
string | encodeToBamStream ()
| Converts the NodePath object into a single stream of data using a BamWriter, and returns that data as a string string.
bool | encodeToBamStream (basic_stringchar data, BamWriter writer)
| Converts the NodePath object into a single stream of data using a BamWriter, and stores that data in the indicated string.
bool | encodeToBamStream (basic_stringchar data)
| Converts the NodePath object into a single stream of data using a BamWriter, and stores that data in the indicated string.
NodePath | find (string path)
| Searches for a node below the referenced node that matches the indicated string.
NodePathCollection | findAllMatches (string path)
| Returns the complete set of all NodePaths that begin with this NodePath and can be extended by path.
MaterialCollection | findAllMaterials ()
| Returns a list of a materials applied to geometry at this node and below.
MaterialCollection | findAllMaterials (string name)
| Returns a list of a materials applied to geometry at this node and below that match the indicated name (which may contain wildcard characters).
NodePathCollection | findAllPathsTo (PandaNode node)
| Returns the set of all NodePaths that extend from this NodePath down to the indicated node.
InternalNameCollection | findAllTexcoords ()
| Returns a list of all texture coordinate sets used by any geometry at this node level and below.
InternalNameCollection | findAllTexcoords (string name)
| Returns a list of all texture coordinate sets used by any geometry at this node level and below that match the indicated name (which may contain wildcard characters).
TextureCollection | findAllTextures ()
| Returns a list of a textures applied to geometry at this node and below.
TextureCollection | findAllTextures (TextureStage stage)
| Returns a list of a textures on geometry at this node and below that are assigned to the indicated texture stage.
TextureCollection | findAllTextures (string name)
| Returns a list of a textures applied to geometry at this node and below that match the indicated name (which may contain wildcard characters).
TextureStageCollection | findAllTextureStages ()
| Returns a list of a TextureStages applied to geometry at this node and below.
TextureStageCollection | findAllTextureStages (string name)
| Returns a list of a TextureStages applied to geometry at this node and below that match the indicated name (which may contain wildcard characters).
InternalNameCollection | findAllVertexColumns ()
| Returns a list of all vertex array columns stored on some geometry found at this node level and below.
InternalNameCollection | findAllVertexColumns (string name)
| Returns a list of all vertex array columns stored on some geometry found at this node level and below that match the indicated name (which may contain wildcard characters).
Material | findMaterial (string name)
| Returns the first material found applied to geometry at this node or below that matches the indicated name (which may contain wildcards).
NodePath | findNetPythonTag (string key)
| Returns the lowest ancestor of this node that contains a tag definition with the indicated key, if any, or an empty NodePath if no ancestor of this node contains this tag definition.
NodePath | findNetTag (string key)
| Returns the lowest ancestor of this node that contains a tag definition with the indicated key, if any, or an empty NodePath if no ancestor of this node contains this tag definition.
NodePath | findPathTo (PandaNode node)
| Searches for the indicated node below this node and returns the shortest NodePath that connects them.
Texture | findTexture (TextureStage stage)
| Returns the first texture found applied to geometry at this node or below that is assigned to the indicated texture stage.
Texture | findTexture (string name)
| Returns the first texture found applied to geometry at this node or below that matches the indicated name (which may contain wildcards).
TextureStage | findTextureStage (string name)
| Returns the first TextureStage found applied to geometry at this node or below that matches the indicated name (which may contain wildcards).
int | flattenLight ()
| Lightly flattens out the hierarchy below this node by applying transforms, colors, and texture matrices from the nodes onto the vertices, but does not remove any nodes.
int | flattenMedium ()
| A more thorough flattening than flatten_light(), this first applies all the transforms, colors, and texture matrices from the nodes onto the vertices, and then removes unneeded grouping nodes--nodes that have exactly one child, for instance, but have no special properties in themselves.
int | flattenStrong ()
| The strongest possible flattening.
| forceRecomputeBounds ()
| Forces the recomputing of all the bounding volumes at every node in the subgraph beginning at this node and below.
NodePath | getAncestor (int index, Thread current_thread)
| Returns the nth ancestor of the path, where 0 is the NodePath itself and get_num_nodes() - 1 is get_top().
NodePath | getAncestor (int index)
| Returns the nth ancestor of the path, where 0 is the NodePath itself and get_num_nodes() - 1 is get_top().
list | getAncestors ()
unsigned short int | getAntialias ()
| Returns the antialias setting that has been specifically set on this node via set_antialias(), or M_none if no setting has been made.
RenderAttrib const | getAttrib (TypeHandle type)
| Returns the render attribute of the indicated type, if it is defined on the node, or NULL if it is not.
float | getAudioVolume ()
| Returns the complete audio volume that has been applied to this node via a previous call to set_audio_volume(), or 1.
int | getBinDrawOrder ()
| Returns the drawing order associated with the bin that this particular node was assigned to via set_bin(), or 0 if no bin was assigned.
string | getBinName ()
| Returns the name of the bin that this particular node was assigned to via set_bin(), or the empty string if no bin was assigned.
BoundingVolume | getBounds (Thread current_thread)
| Returns a newly-allocated bounding volume containing the bottom node and all of its descendants.
BoundingVolume | getBounds ()
| Returns a newly-allocated bounding volume containing the bottom node and all of its descendants.
NodePath | getChild (int n, Thread current_thread)
| Returns a NodePath representing the nth child of the referenced node.
NodePath | getChild (int n)
| Returns a NodePath representing the nth child of the referenced node.
NodePathCollection | getChildren (Thread current_thread)
| Returns the set of all child nodes of the referenced node.
NodePathCollection | getChildren ()
| Returns the set of all child nodes of the referenced node.
BitMaskunsigned | getCollideMask ()
VBase4 | getColor ()
| Returns the color that has been assigned to the node, or black if no color has been assigned.
VBase4 const | getColorScale ()
| Returns the complete color scale vector that has been applied to this node via a previous call to set_color_scale() and/or set_alpha_scale(), or all 1's (identity) if no scale has been applied to this particular node.
NodePath | getCommonAncestor (NodePath const other, Thread current_thread)
| Returns the lowest NodePath that both of these two NodePaths have in common: the first ancestor that both of them share.
NodePath | getCommonAncestor (NodePath const other)
| Returns the lowest NodePath that both of these two NodePaths have in common: the first ancestor that both of them share.
int | getDepthOffset ()
| Returns the depth offset value if it has been specified using set_depth_offset, or 0 if not.
bool | getDepthTest ()
| Returns true if depth-test rendering has been specifically set on this node via set_depth_test(), or false if depth-test rendering has been specifically disabled.
bool | getDepthWrite ()
| Returns true if depth-write rendering has been specifically set on this node via set_depth_write(), or false if depth-write rendering has been specifically disabled.
float | getDistance (NodePath const other)
| Returns the straight-line distance between this referenced node's coordinate frame's origin, and that of the other node's origin.
RenderEffect const | getEffect (TypeHandle type)
| Returns the render effect of the indicated type, if it is defined on the node, or NULL if it is not.
RenderEffects const | getEffects ()
| Returns the complete RenderEffects that will be applied to this node.
ErrorType | getErrorType ()
| If is_empty() is true, this returns a code that represents the reason why the NodePath is empty.
Fog | getFog ()
| Returns the fog that has been set on this particular node, or NULL if no fog has been set.
float | getH ()
float | getH (NodePath const other)
NodePath | getHiddenAncestor (BitMaskunsigned int, 32 camera_mask, Thread current_thread)
| Returns the NodePath at or above the referenced node that is hidden to the indicated camera(s), or an empty NodePath if no ancestor of the referenced node is hidden (and the node should be visible).
NodePath | getHiddenAncestor (BitMaskunsigned int, 32 camera_mask)
| Returns the NodePath at or above the referenced node that is hidden to the indicated camera(s), or an empty NodePath if no ancestor of the referenced node is hidden (and the node should be visible).
NodePath | getHiddenAncestor ()
| Returns the NodePath at or above the referenced node that is hidden to the indicated camera(s), or an empty NodePath if no ancestor of the referenced node is hidden (and the node should be visible).
VBase3 | getHpr ()
| Retrieves the rotation component of the transform.
VBase3 | getHpr (NodePath const other)
| Returns the relative orientation of the bottom node as seen from the other node.
int | getInstanceCount ()
| Returns the geometry instance count, or 0 if disabled.
int | getKey ()
| Returns an integer that is guaranteed to be the same for all NodePaths that represent the same node instance, and different for all NodePaths that represent a different node instance.
Mat4 const | getMat ()
| Returns the transform matrix that has been applied to the referenced node, or the identity matrix if no matrix has been applied.
Mat4 | getMat (NodePath const other)
| Returns the matrix that describes the coordinate space of the bottom node, relative to the other path's bottom node's coordinate space.
Material | getMaterial ()
| Returns the material that has been set on this particular node, or NULL if no material has been set.
string | getName ()
| Returns the name of the referenced node.
float | getNetAudioVolume ()
| Returns the complete audio volume for this node taking highers nodes in the graph into account.
TransformState const | getNetPrevTransform (Thread current_thread)
| Returns the net "previous" transform on this node from the root.
TransformState const | getNetPrevTransform ()
| Returns the net "previous" transform on this node from the root.
PyObject | getNetPythonTag (string key)
| Returns the Python object that has been defined on this node, or the nearest ancestor node, for the indicated key.
RenderState const | getNetState (Thread current_thread)
| Returns the net state on this node from the root.
RenderState const | getNetState ()
| Returns the net state on this node from the root.
string | getNetTag (string key)
| Returns the tag value that has been defined on this node, or the nearest ancestor node, for the indicated key.
TransformState const | getNetTransform (Thread current_thread)
| Returns the net transform on this node from the root.
TransformState const | getNetTransform ()
| Returns the net transform on this node from the root.
PandaNode | getNode (int index, Thread current_thread)
| Returns the nth node of the path, where 0 is the referenced (bottom) node and get_num_nodes() - 1 is the top node.
PandaNode | getNode (int index)
| Returns the nth node of the path, where 0 is the referenced (bottom) node and get_num_nodes() - 1 is the top node.
list | getNodes ()
int | getNumChildren (Thread current_thread)
| Returns the number of children of the referenced node.
int | getNumChildren ()
| Returns the number of children of the referenced node.
int | getNumNodes (Thread current_thread)
| Returns the number of nodes in the path.
int | getNumNodes ()
| Returns the number of nodes in the path.
float | getP ()
float | getP (NodePath const other)
NodePath | getParent (Thread current_thread)
| Returns the NodePath to the parent of the referenced node: that is, this NodePath, shortened by one node.
NodePath | getParent ()
| Returns the NodePath to the parent of the referenced node: that is, this NodePath, shortened by one node.
Point3 | getPos ()
| Retrieves the translation component of the transform.
Point3 | getPos (NodePath const other)
| Returns the relative position of the referenced node as seen from the other node.
Vec3 | getPosDelta ()
| Returns the delta vector from this node's position in the previous frame (according to set_prev_transform(), typically set via the use of set_fluid_pos()) and its position in the current frame.
Vec3 | getPosDelta (NodePath const other)
| Returns the delta vector from this node's position in the previous frame (according to set_prev_transform(), typically set via the use of set_fluid_pos()) and its position in the current frame, as seen in the indicated node's coordinate space.
TransformState const | getPrevTransform (Thread current_thread)
| Returns the transform that has been set as this node's "previous" position.
TransformState const | getPrevTransform ()
| Returns the transform that has been set as this node's "previous" position.
TransformState const | getPrevTransform (NodePath const other)
| Returns the relative "previous" transform to this node from the other node; i.e.
TransformState const | getPrevTransform (NodePath const other, Thread current_thread)
| Returns the relative "previous" transform to this node from the other node; i.e.
PyObject | getPythonTag (string key)
| Retrieves the Python object that was previously set on this node for the particular key, if any.
Quat | getQuat ()
| Retrieves the rotation component of the transform.
Quat | getQuat (NodePath const other)
| Returns the relative orientation of the bottom node as seen from the other node.
float | getR ()
float | getR (NodePath const other)
Point3 | getRelativePoint (NodePath const other, VBase3 const point)
| Given that the indicated point is in the coordinate system of the other node, returns the same point in this node's coordinate system.
Vec3 | getRelativeVector (NodePath const other, VBase3 const vec)
| Given that the indicated vector is in the coordinate system of the other node, returns the same vector in this node's coordinate system.
Mode | getRenderMode ()
| Returns the render mode that has been specifically set on this node via set_render_mode(), or M_unchanged if nothing has been set.
bool | getRenderModePerspective ()
| Returns the flag that has been set on this node via set_render_mode_perspective(), or false if no flag has been set.
float | getRenderModeThickness ()
| Returns the render mode thickness that has been specifically set on this node via set_render_mode(), or 1.0 if nothing has been set.
float | getSa ()
| Gets the alpha scale component of the transform.
float | getSb ()
| Gets the blue scale component of the transform.
VBase3 | getScale ()
| Retrieves the scale component of the transform.
VBase3 | getScale (NodePath const other)
| Returns the relative scale of the bottom node as seen from the other node.
float | getSg ()
| Gets the green scale component of the transform.
Shader const | getShader ()
ShaderInput const | getShaderInput (InternalName const id)
ShaderInput const | getShaderInput (string id)
VBase3 | getShear ()
| Retrieves the shear component of the transform.
VBase3 | getShear (NodePath const other)
| Returns the relative shear of the bottom node as seen from the other node.
float | getShxy ()
float | getShxy (NodePath const other)
| Returns the relative shear of the referenced node as seen from the other node.
float | getShxz ()
float | getShxz (NodePath const other)
float | getShyz ()
float | getShyz (NodePath const other)
int | getSort (Thread current_thread)
| Returns the sort value of the referenced node within its parent; that is, the sort number passed on the last reparenting operation for this node.
int | getSort ()
| Returns the sort value of the referenced node within its parent; that is, the sort number passed on the last reparenting operation for this node.
float | getSr ()
| Gets the red scale component of the transform.
NodePath | getStashedAncestor (Thread current_thread)
| Returns the NodePath at or above the referenced node that is stashed, or an empty NodePath if no ancestor of the referenced node is stashed (and the node should be visible).
NodePath | getStashedAncestor ()
| Returns the NodePath at or above the referenced node that is stashed, or an empty NodePath if no ancestor of the referenced node is stashed (and the node should be visible).
NodePathCollection | getStashedChildren (Thread current_thread)
| Returns the set of all child nodes of the referenced node that have been stashed.
NodePathCollection | getStashedChildren ()
| Returns the set of all child nodes of the referenced node that have been stashed.
RenderState const | getState (NodePath const other, Thread current_thread)
| Returns the state changes that must be made to transition to the render state of this node from the render state of the other node.
RenderState const | getState (NodePath const other)
| Returns the state changes that must be made to transition to the render state of this node from the render state of the other node.
RenderState const | getState (Thread current_thread)
| Returns the complete state object set on this node.
RenderState const | getState ()
| Returns the complete state object set on this node.
float | getSx ()
float | getSx (NodePath const other)
| Returns the relative scale of the referenced node as seen from the other node.
float | getSy ()
float | getSy (NodePath const other)
float | getSz ()
float | getSz (NodePath const other)
string | getTag (string key)
| Retrieves the user-defined value that was previously set on this node for the particular key, if any.
TexGenMode | getTexGen (TextureStage stage)
| Returns the texture coordinate generation mode for the given stage, or M_off if there is no explicit mode set for the given stage.
NodePath | getTexGenLight (TextureStage stage)
| Returns the particular Light set for the indicated texgen mode's texture stage, or empty NodePath if no light is set.
VBase3 | getTexHpr (NodePath const other, TextureStage stage)
| Returns the 3-D HPR set for the UVW's for the given stage on the current node.
VBase3 | getTexHpr (TextureStage stage)
| Returns the 3-D HPR set for the UVW's for the given stage on the current node.
VBase2 | getTexOffset (NodePath const other, TextureStage stage)
| Returns the offset set for the UV's for the given stage on the current node.
VBase2 | getTexOffset (TextureStage stage)
| Returns the offset set for the UV's for the given stage on the current node.
VBase3 | getTexPos (NodePath const other, TextureStage stage)
| Returns the offset set for the UVW's for the given stage on the current node.
VBase3 | getTexPos (TextureStage stage)
| Returns the offset set for the UVW's for the given stage on the current node.
NodePath | getTexProjectorFrom (TextureStage stage)
| Returns the "from" node associated with the TexProjectorEffect on the indicated stage.
NodePath | getTexProjectorTo (TextureStage stage)
| Returns the "to" node associated with the TexProjectorEffect on the indicated stage.
float | getTexRotate (NodePath const other, TextureStage stage)
| Returns the rotation set for the UV's for the given stage on the current node.
float | getTexRotate (TextureStage stage)
| Returns the rotation set for the UV's for the given stage on the current node.
VBase2 | getTexScale (TextureStage stage)
| Returns the scale set for the UV's for the given stage on the current node.
VBase2 | getTexScale (NodePath const other, TextureStage stage)
| Returns the scale set for the UV's for the given stage on the current node.
VBase3 | getTexScale3d (NodePath const other, TextureStage stage)
| Returns the scale set for the UVW's for the given stage on the current node.
VBase3 | getTexScale3d (TextureStage stage)
| Returns the scale set for the UVW's for the given stage on the current node.
TransformState const | getTexTransform (NodePath const other, TextureStage stage)
| Returns the texture matrix on the current node for the given stage, relative to the other node.
TransformState const | getTexTransform (TextureStage stage)
| Returns the texture matrix on the current node for the given stage, or identity transform if there is no explicit transform set for the given stage.
Texture | getTexture ()
| Returns the base-level texture that has been set on this particular node, or NULL if no texture has been set.
Texture | getTexture (TextureStage stage)
| Returns the texture that has been set on the indicated stage for this particular node, or NULL if no texture has been set for this stage.
NodePath | getTop (Thread current_thread)
| Returns a singleton NodePath that represents the top of the path, or empty NodePath if this path is empty.
NodePath | getTop ()
| Returns a singleton NodePath that represents the top of the path, or empty NodePath if this path is empty.
PandaNode | getTopNode (Thread current_thread)
| Returns the top node of the path, or NULL if the path is empty.
PandaNode | getTopNode ()
| Returns the top node of the path, or NULL if the path is empty.
TransformState const | getTransform (NodePath const other, Thread current_thread)
| Returns the relative transform to this node from the other node; i.e.
TransformState const | getTransform (NodePath const other)
| Returns the relative transform to this node from the other node; i.e.
TransformState const | getTransform (Thread current_thread)
| Returns the complete transform object set on this node.
TransformState const | getTransform ()
| Returns the complete transform object set on this node.
Mode | getTransparency ()
| Returns the transparent rendering that has been specifically set on this node via set_transparency(), or M_none if nontransparent rendering has been specifically set, or if nothing has been specifically set.
bool | getTwoSided ()
| Returns true if two-sided rendering has been specifically set on this node via set_two_sided(), or false if one-sided rendering has been specifically set, or if nothing has been specifically set.
float | getX (NodePath const other)
float | getX ()
float | getY ()
float | getY (NodePath const other)
float | getZ (NodePath const other)
float | getZ ()
bool | hasAntialias ()
| Returns true if an antialias setting has been explicitly mode on this particular node via set_antialias().
bool | hasAttrib (TypeHandle type)
| Returns true if there is a render attribute of the indicated type defined on this node, or false if there is not.
bool | hasAudioVolume ()
| Returns true if an audio volume has been applied to the referenced node, false otherwise.
bool | hasBillboard ()
| Returns true if there is any billboard effect on the node.
bool | hasBin ()
| Returns true if the node has been assigned to the a particular rendering bin via set_bin(), false otherwise.
bool | hasClipPlane (NodePath const clip_plane)
| Returns true if the indicated clipping plane has been specifically applied to this particular node.
bool | hasClipPlaneOff (NodePath const clip_plane)
| Returns true if the indicated clipping plane has been specifically disabled on this particular node.
bool | hasClipPlaneOff ()
| Returns true if all clipping planes have been specifically disabled on this particular node.
bool | hasColor ()
| Returns true if a color has been applied to the given node, false otherwise.
bool | hasColorScale ()
| Returns true if a color scale has been applied to the referenced node, false otherwise.
bool | hasCompass ()
| Returns true if there is any compass effect on the node.
bool | hasDepthOffset ()
| Returns true if a depth-offset adjustment has been explicitly set on this particular node via set_depth_offset().
bool | hasDepthTest ()
| Returns true if a depth-test adjustment has been explicitly set on this particular node via set_depth_test().
bool | hasDepthWrite ()
| Returns true if a depth-write adjustment has been explicitly set on this particular node via set_depth_write().
bool | hasEffect (TypeHandle type)
| Returns true if there is a render effect of the indicated type defined on this node, or false if there is not.
bool | hasFog ()
| Returns true if a fog has been applied to this particular node via set_fog(), false otherwise.
bool | hasFogOff ()
| Returns true if a fog has been specifically disabled on this particular node via set_fog_off(), false otherwise.
bool | hasLight (NodePath const light)
| Returns true if the indicated Light or PolylightNode has been specifically enabled on this particular node.
bool | hasLightOff ()
| Returns true if all Lights have been specifically disabled on this particular node.
bool | hasLightOff (NodePath const light)
| Returns true if the indicated Light has been specifically disabled on this particular node.
bool | hasMat ()
| Returns true if a non-identity transform matrix has been applied to the referenced node, false otherwise.
bool | hasMaterial ()
| Returns true if a material has been applied to this particular node via set_material(), false otherwise.
bool | hasNetPythonTag (string key)
| Returns true if the indicated Python object has been defined on this node or on any ancestor node, or false otherwise.
bool | hasNetTag (string key)
| Returns true if the indicated tag value has been defined on this node or on any ancestor node, or false otherwise.
bool | hasOccluder (NodePath const occluder)
| Returns true if the indicated occluder has been specifically applied to this particular node.
bool | hasParent (Thread current_thread)
| Returns true if the referenced node has a parent; i.e.
bool | hasParent ()
| Returns true if the referenced node has a parent; i.e.
bool | hasPythonTag (string key)
| Returns true if a Python object has been defined on this node for the particular key (even if that value is the empty string), or false if no value has been set.
bool | hasRenderMode ()
| Returns true if a render mode has been explicitly set on this particular node via set_render_mode() (or set_render_mode_wireframe() or set_render_mode_filled()), false otherwise.
bool | hasScissor ()
| Returns true if a scissor region was defined at this node by a previous call to set_scissor().
bool | hasTag (string key)
| Returns true if a value has been defined on this node for the particular key (even if that value is the empty string), or false if no value has been set.
bool | hasTexcoord (string texcoord_name)
| Returns true if there are at least some vertices at this node and below that use the named texture coordinate set, false otherwise.
bool | hasTexGen (TextureStage stage)
| Returns true if there is a mode for automatic texture coordinate generation on the current node for the given stage.
bool | hasTexProjector (TextureStage stage)
| Returns true if this node has a TexProjectorEffect for the indicated stage, false otherwise.
bool | hasTexTransform (TextureStage stage)
| Returns true if there is an explicit texture matrix on the current node for the given stage.
bool | hasTexture ()
| Returns true if a texture has been applied to this particular node via set_texture(), false otherwise.
bool | hasTexture (TextureStage stage)
| Returns true if texturing has been specifically enabled on this particular node for the indicated stage.
bool | hasTextureOff ()
| Returns true if texturing has been specifically disabled on this particular node via set_texture_off(), false otherwise.
bool | hasTextureOff (TextureStage stage)
| Returns true if texturing has been specifically disabled on this particular node for the indicated stage.
bool | hasTransparency ()
| Returns true if a transparent-rendering adjustment has been explicitly set on this particular node via set_transparency().
bool | hasTwoSided ()
| Returns true if a two-sided adjustment has been explicitly set on this particular node via set_two_sided().
bool | hasVertexColumn (InternalName const name)
| Returns true if there are at least some vertices at this node and below that contain a reference to the indicated vertex data column name, false otherwise.
| headsUp (Point3 const point, Vec3 const up)
| Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.
| headsUp (Point3 const point)
| Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.
| headsUp (NodePath const other, Point3 const point, Vec3 const up)
| Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.
| headsUp (NodePath const other, Point3 const point)
| Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.
| headsUp (NodePath const other)
| Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.
| headsUp (NodePath const other, float x, float y, float z)
| Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.
| headsUp (float x, float y, float z)
| Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.
| hide ()
| Makes the referenced node (and the entire subgraph below this node) invisible to all cameras.
| hide (BitMaskunsigned int, 32 camera_mask)
| Makes the referenced node invisible just to the cameras whose camera_mask shares the indicated bits.
| hideBounds ()
| Stops the rendering of the bounding volume begun with show_bounds().
NodePath | instanceTo (NodePath const other, int sort, Thread current_thread)
| Adds the referenced node of the NodePath as a child of the referenced node of the indicated other NodePath.
NodePath | instanceTo (NodePath const other, int sort)
| Adds the referenced node of the NodePath as a child of the referenced node of the indicated other NodePath.
NodePath | instanceTo (NodePath const other)
| Adds the referenced node of the NodePath as a child of the referenced node of the indicated other NodePath.
NodePath | instanceUnderNode (NodePath const other, string name, int sort, Thread current_thread)
| Behaves like instance_to(), but implicitly creates a new node to instance the geometry under, and returns a NodePath to that new node.
NodePath | instanceUnderNode (NodePath const other, string name, int sort)
| Behaves like instance_to(), but implicitly creates a new node to instance the geometry under, and returns a NodePath to that new node.
NodePath | instanceUnderNode (NodePath const other, string name)
| Behaves like instance_to(), but implicitly creates a new node to instance the geometry under, and returns a NodePath to that new node.
bool | isAncestorOf (NodePath const other, Thread current_thread)
| Returns true if the node represented by this NodePath is a parent or other ancestor of the other NodePath, or false if it is not.
bool | isAncestorOf (NodePath const other)
| Returns true if the node represented by this NodePath is a parent or other ancestor of the other NodePath, or false if it is not.
bool | isEmpty ()
| Returns true if the NodePath contains no nodes.
bool | isHidden (BitMaskunsigned int, 32 camera_mask)
| Returns true if the referenced node is hidden from the indicated camera(s) either directly, or because some ancestor is hidden.
bool | isHidden ()
| Returns true if the referenced node is hidden from the indicated camera(s) either directly, or because some ancestor is hidden.
bool | isSameGraph (NodePath const other)
| Returns true if the node represented by this NodePath is parented within the same graph as that of the other NodePath.
bool | isSameGraph (NodePath const other, Thread current_thread)
| Returns true if the node represented by this NodePath is parented within the same graph as that of the other NodePath.
bool | isSingleton ()
| Returns true if the NodePath contains exactly one node.
bool | isSingleton (Thread current_thread)
| Returns true if the NodePath contains exactly one node.
bool | isStashed ()
| Returns true if the referenced node is stashed either directly, or because some ancestor is stashed.
| listTags ()
| Lists the tags to the nout stream, one per line.
| lookAt (Point3 const point)
| Sets the hpr on this NodePath so that it rotates to face the indicated point in space.
| lookAt (NodePath const other, Point3 const point, Vec3 const up)
| Sets the transform on this NodePath so that it rotates to face the indicated point in space, which is relative to the other NodePath.
| lookAt (NodePath const other, Point3 const point)
| Sets the transform on this NodePath so that it rotates to face the indicated point in space, which is relative to the other NodePath.
| lookAt (NodePath const other)
| Sets the transform on this NodePath so that it rotates to face the indicated point in space, which is relative to the other NodePath.
| lookAt (NodePath const other, float x, float y, float z)
| Sets the hpr on this NodePath so that it rotates to face the indicated point in space, which is relative to the other NodePath.
| lookAt (float x, float y, float z)
| Sets the transform on this NodePath so that it rotates to face the indicated point in space.
| lookAt (Point3 const point, Vec3 const up)
| Sets the hpr on this NodePath so that it rotates to face the indicated point in space.
| ls (ostream out, int indent_level)
| Lists the hierarchy at and below the referenced node.
| ls (ostream out)
| Lists the hierarchy at and below the referenced node.
| ls ()
| Lists the hierarchy at and below the referenced node.
PandaNode | node ()
| Returns the referenced node of the path.
bool | operator!= (NodePath const other)
| Returns true if the two paths are not equivalent.
bool | operator< (NodePath const other)
| Returns true if this NodePath sorts before the other one, false otherwise.
NodePath | operator= (NodePath const copy)
bool | operator== (NodePath const other)
| Returns true if the two paths are equivalent; that is, if they contain the same list of nodes in the same order.
| output (ostream out)
| Writes a sensible description of the NodePath to the indicated output stream.
| premungeScene (GraphicsStateGuardianBase gsg)
| Walks through the scene graph beginning at the bottom node, and internally adjusts any GeomVertexFormats for optimal rendering on the indicated GSG.
| premungeScene ()
| Walks through the scene graph beginning at the bottom node, and internally adjusts any GeomVertexFormats for optimal rendering on the indicated GSG.
| prepareScene (GraphicsStateGuardianBase gsg)
| Walks through the scene graph beginning at the bottom node, and does whatever initialization is required to render the scene properly with the indicated GSG.
| projectTexture (TextureStage stage, Texture tex, NodePath const projector)
| A convenience function to enable projective texturing at this node level and below, using the indicated NodePath (which should contain a LensNode) as the projector.
PyObject | reduce (PyObject self)
| This special Python method is implement to provide support for the pickle module.
PyObject | reducePersist (PyObject self, PyObject pickler)
| This special Python method is implement to provide support for the pickle module.
| removeNode (Thread current_thread)
| Disconnects the referenced node from the scene graph.
| removeNode ()
| Disconnects the referenced node from the scene graph.
| reparentTo (NodePath const other, int sort, Thread current_thread)
| Removes the referenced node of the NodePath from its current parent and attaches it to the referenced node of the indicated NodePath.
| reparentTo (NodePath const other, int sort)
| Removes the referenced node of the NodePath from its current parent and attaches it to the referenced node of the indicated NodePath.
| reparentTo (NodePath const other)
| Removes the referenced node of the NodePath from its current parent and attaches it to the referenced node of the indicated NodePath.
| reverseLs ()
| Lists the hierarchy at and above the referenced node.
int | reverseLs (ostream out, int indent_level)
| Lists the hierarchy at and above the referenced node.
int | reverseLs (ostream out)
| Lists the hierarchy at and above the referenced node.
| setAllColorScale (float scale, int priority)
| Scales all the color components of the object by the same amount, darkening the object, without (much) affecting alpha.
| setAllColorScale (float scale)
| Scales all the color components of the object by the same amount, darkening the object, without (much) affecting alpha.
| setAlphaScale (float scale, int priority)
| Sets the alpha scale component of the transform without (much) affecting the color scale.
| setAlphaScale (float scale)
| Sets the alpha scale component of the transform without (much) affecting the color scale.
| setAntialias (unsigned short int mode, int priority)
| Specifies the antialiasing type that should be applied at this node and below.
| setAntialias (unsigned short int mode)
| Specifies the antialiasing type that should be applied at this node and below.
| setAttrib (RenderAttrib const attrib, int priority)
| Adds the indicated render attribute to the scene graph on this node.
| setAttrib (RenderAttrib const attrib)
| Adds the indicated render attribute to the scene graph on this node.
| setAudioVolume (float volume)
| Sets the audio volume component of the transform.
| setAudioVolume (float volume, int priority)
| Sets the audio volume component of the transform.
| setAudioVolumeOff (int priority)
| Disables any audio volume attribute inherited from above.
| setAudioVolumeOff ()
| Disables any audio volume attribute inherited from above.
| setBillboardAxis (NodePath const camera, float offset)
| Puts a billboard transition on the node such that it will rotate in two dimensions around the up axis, towards a specified "camera" instead of to the viewing camera.
| setBillboardAxis (float offset)
| Puts a billboard transition on the node such that it will rotate in two dimensions around the up axis.
| setBillboardAxis ()
| Puts a billboard transition on the node such that it will rotate in two dimensions around the up axis.
| setBillboardPointEye (float offset)
| Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the top of the camera.
| setBillboardPointEye ()
| Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the top of the camera.
| setBillboardPointEye (NodePath const camera, float offset)
| Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the top of the camera, towards a specified "camera" instead of to the viewing camera.
| setBillboardPointWorld (NodePath const camera, float offset)
| Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the sky, towards a specified "camera" instead of to the viewing camera.
| setBillboardPointWorld ()
| Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the sky.
| setBillboardPointWorld (float offset)
| Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the sky.
| setBin (string bin_name, int draw_order, int priority)
| Assigns the geometry at this level and below to the named rendering bin.
| setBin (string bin_name, int draw_order)
| Assigns the geometry at this level and below to the named rendering bin.
| setClipPlane (NodePath const clip_plane)
| Adds the indicated clipping plane to the list of planes that apply to geometry at this node and below.
| setClipPlane (NodePath const clip_plane, int priority)
| Adds the indicated clipping plane to the list of planes that apply to geometry at this node and below.
| setClipPlaneOff (NodePath const clip_plane)
| Sets the geometry at this level and below to render without being clipped by the indicated PlaneNode.
| setClipPlaneOff ()
| Sets the geometry at this level and below to render using no clip_planes at all.
| setClipPlaneOff (int priority)
| Sets the geometry at this level and below to render using no clip_planes at all.
| setClipPlaneOff (NodePath const clip_plane, int priority)
| Sets the geometry at this level and below to render without being clipped by the indicated PlaneNode.
| setCollideMask (BitMaskunsigned int, 32 new_mask, BitMaskunsigned int, 32 bits_to_change, TypeHandle node_type)
| Recursively applies the indicated CollideMask to the into_collide_masks for all nodes at this level and below.
| setCollideMask (BitMaskunsigned int, 32 new_mask)
| Recursively applies the indicated CollideMask to the into_collide_masks for all nodes at this level and below.
| setCollideMask (BitMaskunsigned int, 32 new_mask, BitMaskunsigned int, 32 bits_to_change)
| Recursively applies the indicated CollideMask to the into_collide_masks for all nodes at this level and below.
| setColor (VBase4 const color)
| Applies a scene-graph color to the referenced node.
| setColor (float r, float g, float b, float a, int priority)
| Applies a scene-graph color to the referenced node.
| setColor (float r, float g, float b, float a)
| Applies a scene-graph color to the referenced node.
| setColor (float r, float g, float b)
| Applies a scene-graph color to the referenced node.
| setColor (VBase4 const color, int priority)
| Applies a scene-graph color to the referenced node.
| setColorOff (int priority)
| Sets the geometry at this level and below to render using the geometry color.
| setColorOff ()
| Sets the geometry at this level and below to render using the geometry color.
| setColorScale (VBase4 const scale)
| Sets the color scale component of the transform, leaving translation and rotation untouched.
| setColorScale (float sx, float sy, float sz, float sa, int priority)
| Sets the color scale component of the transform.
| setColorScale (float sx, float sy, float sz, float sa)
| Sets the color scale component of the transform.
| setColorScale (VBase4 const scale, int priority)
| Sets the color scale component of the transform, leaving translation and rotation untouched.
| setColorScaleOff ()
| Disables any color scale attribute inherited from above.
| setColorScaleOff (int priority)
| Disables any color scale attribute inherited from above.
| setCompass ()
| Puts a compass effect on the node, so that it will retain a fixed rotation relative to the reference node (or render if the reference node is empty) regardless of the transforms above it.
| setCompass (NodePath const reference)
| Puts a compass effect on the node, so that it will retain a fixed rotation relative to the reference node (or render if the reference node is empty) regardless of the transforms above it.
| setDepthOffset (int bias, int priority)
| This instructs the graphics driver to apply an offset or bias to the generated depth values for rendered polygons, before they are written to the depth buffer.
| setDepthOffset (int bias)
| This instructs the graphics driver to apply an offset or bias to the generated depth values for rendered polygons, before they are written to the depth buffer.
| setDepthTest (bool depth_test)
| Specifically sets or disables the testing of the depth buffer on this particular node.
| setDepthTest (bool depth_test, int priority)
| Specifically sets or disables the testing of the depth buffer on this particular node.
| setDepthWrite (bool depth_write, int priority)
| Specifically sets or disables the writing to the depth buffer on this particular node.
| setDepthWrite (bool depth_write)
| Specifically sets or disables the writing to the depth buffer on this particular node.
| setEffect (RenderEffect const effect)
| Adds the indicated render effect to the scene graph on this node.
| setEffects (RenderEffects const effects)
| Sets the complete RenderEffects that will be applied this node.
| setFluidPos (float x, float y, float z)
| Sets the translation component, without changing the "previous" position, so that the collision system will see the node as moving fluidly from its previous position to its new position.
| setFluidPos (VBase3 const pos)
| Sets the translation component, without changing the "previous" position, so that the collision system will see the node as moving fluidly from its previous position to its new position.
| setFluidPos (NodePath const other, VBase3 const pos)
| Sets the translation component of the transform, relative to the other node.
| setFluidPos (NodePath const other, float x, float y, float z)
| Sets the translation component, without changing the "previous" position, so that the collision system will see the node as moving fluidly from its previous position to its new position.
| setFluidX (NodePath const other, float x)
| setFluidX (float x)
| setFluidY (NodePath const other, float y)
| setFluidY (float y)
| setFluidZ (float z)
| setFluidZ (NodePath const other, float z)
| setFog (Fog fog)
| Sets the geometry at this level and below to render using the indicated fog.
| setFog (Fog fog, int priority)
| Sets the geometry at this level and below to render using the indicated fog.
| setFogOff ()
| Sets the geometry at this level and below to render using no fog.
| setFogOff (int priority)
| Sets the geometry at this level and below to render using no fog.
| setH (float h)
| setH (NodePath const other, float h)
| setHpr (NodePath const other, float h, float p, float r)
| Sets the rotation component of the transform, relative to the other node.
| setHpr (float h, float p, float r)
| Sets the rotation component of the transform, leaving translation and scale untouched.
| setHpr (VBase3 const hpr)
| Sets the rotation component of the transform, leaving translation and scale untouched.
| setHpr (NodePath const other, VBase3 const hpr)
| Sets the rotation component of the transform, relative to the other node.
| setHprScale (VBase3 const hpr, VBase3 const scale)
| Sets the rotation and scale components of the transform, leaving translation untouched.
| setHprScale (NodePath const other, VBase3 const hpr, VBase3 const scale)
| Sets the rotation and scale components of the transform, leaving translation untouched.
| setHprScale (NodePath const other, float h, float p, float r, float sx, float sy, float sz)
| Sets the rotation and scale components of the transform, leaving translation untouched.
| setHprScale (float h, float p, float r, float sx, float sy, float sz)
| Sets the rotation and scale components of the transform, leaving translation untouched.
| setInstanceCount (int instance_count)
| Sets the geometry instance count, or 0 if geometry instancing should be disabled.
| setLight (NodePath const light)
| Adds the indicated Light or PolylightNode to the list of lights that illuminate geometry at this node and below.
| setLight (NodePath const light, int priority)
| Adds the indicated Light or PolylightNode to the list of lights that illuminate geometry at this node and below.
| setLightOff (NodePath const light, int priority)
| Sets the geometry at this level and below to render without using the indicated Light.
| setLightOff (NodePath const light)
| Sets the geometry at this level and below to render without using the indicated Light.
| setLightOff (int priority)
| Sets the geometry at this level and below to render using no lights at all.
| setLightOff ()
| Sets the geometry at this level and below to render using no lights at all.
| setMat (Mat4 const mat)
| Directly sets an arbitrary 4x4 transform matrix.
| setMat (NodePath const other, Mat4 const mat)
| Converts the indicated matrix from the other's coordinate space to the local coordinate space, and applies it to the node.
| setMaterial (Material tex)
| Sets the geometry at this level and below to render using the indicated material.
| setMaterial (Material tex, int priority)
| Sets the geometry at this level and below to render using the indicated material.
| setMaterialOff (int priority)
| Sets the geometry at this level and below to render using no material.
| setMaterialOff ()
| Sets the geometry at this level and below to render using no material.
| setName (string name)
| Changes the name of the referenced node.
| setNormalMap (Texture normal_map, string texcoord_name, bool preserve_color)
| A convenience function to set up a normal map on this geometry.
| setNormalMap (Texture normal_map)
| A convenience function to set up a normal map on this geometry.
| setNormalMap (Texture normal_map, string texcoord_name)
| A convenience function to set up a normal map on this geometry.
| setOccluder (NodePath const occluder)
| Adds the indicated occluder to the list of occluders that apply to geometry at this node and below.
| setP (NodePath const other, float p)
| setP (float p)
| setPos (VBase3 const pos)
| Sets the translation component of the transform, leaving rotation and scale untouched.
| setPos (NodePath const other, VBase3 const pos)
| Sets the translation component of the transform, relative to the other node.
| setPos (float x, float y, float z)
| Sets the translation component of the transform, leaving rotation and scale untouched.
| setPos (NodePath const other, float x, float y, float z)
| Sets the translation component of the transform, relative to the other node.
| setPosHpr (VBase3 const pos, VBase3 const hpr)
| Sets the translation and rotation component of the transform, leaving scale untouched.
| setPosHpr (NodePath const other, VBase3 const pos, VBase3 const hpr)
| Sets the translation and rotation component of the transform, relative to the other node.
| setPosHpr (NodePath const other, float x, float y, float z, float h, float p, float r)
| Sets the translation and rotation component of the transform, relative to the other node.
| setPosHpr (float x, float y, float z, float h, float p, float r)
| Sets the translation and rotation component of the transform, leaving scale untouched.
| setPosHprScale (float x, float y, float z, float h, float p, float r, float sx, float sy, float sz)
| Completely replaces the transform with new translation, rotation, and scale components.
| setPosHprScale (VBase3 const pos, VBase3 const hpr, VBase3 const scale)
| Replaces the translation, rotation, and scale components, implicitly setting shear to 0.
| setPosHprScale (NodePath const other, VBase3 const pos, VBase3 const hpr, VBase3 const scale)
| Completely replaces the transform with new translation, rotation, and scale components, relative to the other node, implicitly setting shear to 0.
| setPosHprScale (NodePath const other, float x, float y, float z, float h, float p, float r, float sx, float sy, float sz)
| Completely replaces the transform with new translation, rotation, and scale components, relative to the other node.
| setPosHprScaleShear (VBase3 const pos, VBase3 const hpr, VBase3 const scale, VBase3 const shear)
| Completely replaces the transform with new translation, rotation, scale, and shear components.
| setPosHprScaleShear (NodePath const other, VBase3 const pos, VBase3 const hpr, VBase3 const scale, VBase3 const shear)
| Completely replaces the transform with new translation, rotation, scale, and shear components, relative to the other node.
| setPosQuat (VBase3 const pos, Quat const quat)
| Sets the translation and rotation component of the transform, leaving scale untouched.
| setPosQuat (NodePath const other, VBase3 const pos, Quat const quat)
| Sets the translation and rotation component of the transform, relative to the other node.
| setPosQuatScale (VBase3 const pos, Quat const quat, VBase3 const scale)
| Replaces the translation, rotation, and scale components, implicitly setting shear to 0.
| setPosQuatScale (NodePath const other, VBase3 const pos, Quat const quat, VBase3 const scale)
| Completely replaces the transform with new translation, rotation, and scale components, relative to the other node, implicitly setting shear to 0.
| setPosQuatScaleShear (VBase3 const pos, Quat const quat, VBase3 const scale, VBase3 const shear)
| Completely replaces the transform with new translation, rotation, scale, and shear components.
| setPosQuatScaleShear (NodePath const other, VBase3 const pos, Quat const quat, VBase3 const scale, VBase3 const shear)
| Completely replaces the transform with new translation, rotation, scale, and shear components, relative to the other node.
| setPrevTransform (NodePath const other, TransformState const transform, Thread current_thread)
| Sets the "previous" transform object on this node, relative to the other node.
| setPrevTransform (TransformState const transform, Thread current_thread)
| Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.
| setPrevTransform (NodePath const other, TransformState const transform)
| Sets the "previous" transform object on this node, relative to the other node.
| setPrevTransform (TransformState const transform)
| Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.
| setPythonTag (string key, PyObject value)
| Associates an arbitrary Python object with a user-defined key which is stored on the node.
| setQuat (Quat const quat)
| Sets the rotation component of the transform, leaving translation and scale untouched.
| setQuat (NodePath const other, Quat const quat)
| Sets the rotation component of the transform, relative to the other node.
| setQuatScale (Quat const quat, VBase3 const scale)
| Sets the rotation and scale components of the transform, leaving translation untouched.
| setQuatScale (NodePath const other, Quat const quat, VBase3 const scale)
| Sets the rotation and scale components of the transform, leaving translation untouched.
| setR (NodePath const other, float r)
| setR (float r)
| setRenderMode (Mode mode, float thickness, int priority)
| Sets up the geometry at this level and below (unless overridden) to render in the specified mode and with the indicated line and/or point thickness.
| setRenderMode (Mode mode, float thickness)
| Sets up the geometry at this level and below (unless overridden) to render in the specified mode and with the indicated line and/or point thickness.
| setRenderModeFilled ()
| Sets up the geometry at this level and below (unless overridden) to render in filled (i.e.
| setRenderModeFilled (int priority)
| Sets up the geometry at this level and below (unless overridden) to render in filled (i.e.
| setRenderModePerspective (bool perspective, int priority)
| Sets up the point geometry at this level and below to render as perspective sprites (that is, billboarded quads).
| setRenderModePerspective (bool perspective)
| Sets up the point geometry at this level and below to render as perspective sprites (that is, billboarded quads).
| setRenderModeThickness (float thickness, int priority)
| Sets up the point geometry at this level and below to render as thick points (that is, billboarded quads).
| setRenderModeThickness (float thickness)
| Sets up the point geometry at this level and below to render as thick points (that is, billboarded quads).
| setRenderModeWireframe (int priority)
| Sets up the geometry at this level and below (unless overridden) to render in wireframe mode.
| setRenderModeWireframe ()
| Sets up the geometry at this level and below (unless overridden) to render in wireframe mode.
| setSa (float sa)
| Sets the alpha scale component of the transform.
| setSb (float sb)
| Sets the blue scale component of the transform.
| setScale (VBase3 const scale)
| Sets the scale component of the transform, leaving translation and rotation untouched.
| setScale (NodePath const other, VBase3 const scale)
| Sets the scale component of the transform, relative to the other node.
| setScale (NodePath const other, float scale)
| Sets the scale component of the transform, relative to the other node.
| setScale (NodePath const other, float sx, float sy, float sz)
| Sets the scale component of the transform, relative to the other node.
| setScale (float scale)
| Sets the scale component of the transform, leaving translation and rotation untouched.
| setScale (float sx, float sy, float sz)
| setScissor (Point3 const a, Point3 const b)
| Sets up a scissor region on the nodes rendered at this level and below.
| setScissor (Point3 const a, Point3 const b, Point3 const c, Point3 const d)
| Sets up a scissor region on the nodes rendered at this level and below.
| setScissor (NodePath const other, Point3 const a, Point3 const b, Point3 const c, Point3 const d)
| Sets up a scissor region on the nodes rendered at this level and below.
| setScissor (float left, float right, float bottom, float top)
| Sets up a scissor region on the nodes rendered at this level and below.
| setScissor (NodePath const other, Point3 const a, Point3 const b)
| Sets up a scissor region on the nodes rendered at this level and below.
| setSg (float sg)
| Sets the alpha scale component of the transform.
| setShader (Shader const sha)
| setShader (Shader const sha, int priority)
| setShaderAuto ()
| setShaderAuto (BitMaskunsigned int, 32 shader_switch, int priority)
| overloaded for auto shader customization
| setShaderAuto (BitMaskunsigned int, 32 shader_switch)
| overloaded for auto shader customization
| setShaderAuto (int priority)
| setShaderInput (InternalName const id, Texture tex, int priority)
| setShaderInput (string id, PointerToArrayVBase2 const v)
| setShaderInput (InternalName const id, Mat4 const v, int priority)
| setShaderInput (InternalName const id, PointerToArrayMat3 const v, int priority)
| setShaderInput (string id, Mat3 const v)
| setShaderInput (string id, PointerToArrayVBase3 const v)
| setShaderInput (InternalName const id, PointerToArrayUnalignedLVecBase4f const v, int priority)
| setShaderInput (InternalName const id, VBase4 const v, int priority)
| setShaderInput (string id, VBase3 const v)
| setShaderInput (InternalName const id, NodePath const np)
| setShaderInput (string id, Mat4 const v, int priority)
| setShaderInput (string id, PointerToArraydouble const v)
| setShaderInput (string id, PointerToArrayUnalignedLVecBase4f const v)
| setShaderInput (InternalName const id, double n1)
| setShaderInput (string id, VBase2 const v)
| setShaderInput (string id, double n1, double n2, double n3, double n4)
| setShaderInput (InternalName const id, NodePath const np, int priority)
| setShaderInput (string id, PointerToArrayfloat const v)
| setShaderInput (InternalName const id, PointerToArraydouble const v)
| setShaderInput (ShaderInput const inp)
| setShaderInput (string id, PointerToArrayfloat const v, int priority)
| setShaderInput (string id, double n1, double n2)
| setShaderInput (InternalName const id, PointerToArrayVBase2 const v)
| setShaderInput (InternalName const id, Mat4 const v)
| setShaderInput (string id, PointerToArrayVBase3 const v, int priority)
| setShaderInput (string id, Mat3 const v, int priority)
| setShaderInput (string id, VBase4 const v)
| setShaderInput (string id, VBase4 const v, int priority)
| setShaderInput (InternalName const id, double n1, double n2, double n3, double n4, int priority)
| setShaderInput (string id, PointerToArrayVBase2 const v, int priority)
| setShaderInput (string id, PointerToArrayUnalignedLVecBase4f const v, int priority)
| setShaderInput (InternalName const id, Mat3 const v, int priority)
| setShaderInput (InternalName const id, PointerToArrayVBase2 const v, int priority)
| setShaderInput (InternalName const id, Mat3 const v)
| setShaderInput (InternalName const id, Texture tex)
| setShaderInput (InternalName const id, VBase2 const v)
| setShaderInput (InternalName const id, VBase4 const v)
| setShaderInput (InternalName const id, VBase3 const v, int priority)
| setShaderInput (InternalName const id, PointerToArrayMat3 const v)
| setShaderInput (InternalName const id, PointerToArrayVBase3 const v)
| setShaderInput (InternalName const id, PointerToArrayUnalignedLMatrix4f const v)
| setShaderInput (InternalName const id, PointerToArrayUnalignedLVecBase4f const v)
| setShaderInput (InternalName const id, PointerToArraydouble const v, int priority)
| setShaderInput (InternalName const id, PointerToArrayfloat const v)
| setShaderInput (InternalName const id, double n1, double n2, double n3, double n4)
| setShaderInput (InternalName const id, double n1, double n2, double n3)
| setShaderInput (InternalName const id, double n1, double n2)
| setShaderInput (InternalName const id)
| setShaderInput (string id, VBase2 const v, int priority)
| setShaderInput (string id, VBase3 const v, int priority)
| setShaderInput (InternalName const id, VBase3 const v)
| setShaderInput (InternalName const id, PointerToArrayUnalignedLMatrix4f const v, int priority)
| setShaderInput (string id, NodePath const np, int priority)
| setShaderInput (string id, NodePath const np)
| setShaderInput (string id)
| setShaderInput (string id, PointerToArrayUnalignedLMatrix4f const v, int priority)
| setShaderInput (string id, PointerToArrayUnalignedLMatrix4f const v)
| setShaderInput (string id, PointerToArraydouble const v, int priority)
| setShaderInput (string id, double n1, double n2, double n3, double n4, int priority)
| setShaderInput (string id, Texture tex, int priority)
| setShaderInput (string id, Texture tex)
| setShaderInput (string id, double n1, double n2, double n3)
| setShaderInput (string id, PointerToArrayMat3 const v, int priority)
| setShaderInput (InternalName const id, VBase2 const v, int priority)
| setShaderInput (string id, PointerToArrayMat3 const v)
| setShaderInput (string id, double n1)
| setShaderInput (string id, Mat4 const v)
| setShaderInput (InternalName const id, PointerToArrayVBase3 const v, int priority)
| setShaderInput (InternalName const id, PointerToArrayfloat const v, int priority)
| setShaderOff (int priority)
| setShaderOff ()
| setShear (NodePath const other, float shxy, float shxz, float shyz)
| Sets the shear component of the transform, relative to the other node.
| setShear (float shxy, float shxz, float shyz)
| Sets the shear component of the transform, leaving translation, rotation, and scale untouched.
| setShear (VBase3 const shear)
| Sets the shear component of the transform, leaving translation and rotation untouched.
| setShear (NodePath const other, VBase3 const shear)
| Sets the shear component of the transform, relative to the other node.
| setShxy (NodePath const other, float shxy)
| setShxy (float shxy)
| setShxz (float shxz)
| setShxz (NodePath const other, float shxz)
| setShyz (float shyz)
| setShyz (NodePath const other, float shyz)
| setSr (float sr)
| Sets the red scale component of the transform.
| setState (NodePath const other, RenderState const state)
| Sets the state object on this node, relative to the other node.
| setState (NodePath const other, RenderState const state, Thread current_thread)
| Sets the state object on this node, relative to the other node.
| setState (RenderState const state, Thread current_thread)
| Changes the complete state object on this node.
| setState (RenderState const state)
| Changes the complete state object on this node.
| setSx (float sx)
| setSx (NodePath const other, float sx)
| setSy (float sy)
| setSy (NodePath const other, float sy)
| setSz (NodePath const other, float sz)
| setSz (float sz)
| setTag (string key, string value)
| Associates a user-defined value with a user-defined key which is stored on the node.
| setTexGen (TextureStage stage, TexGenMode mode, int priority)
| Enables automatic texture coordinate generation for the indicated texture stage.
| setTexGen (TextureStage stage, TexGenMode mode, string source_name, NodePath const light, int priority)
| Enables automatic texture coordinate generation for the indicated texture stage.
| setTexGen (TextureStage stage, TexGenMode mode)
| Enables automatic texture coordinate generation for the indicated texture stage.
| setTexGen (TextureStage stage, TexGenMode mode, string source_name, NodePath const light)
| Enables automatic texture coordinate generation for the indicated texture stage.
| setTexGen (TextureStage stage, TexGenMode mode, Point3 const constant_value)
| Enables automatic texture coordinate generation for the indicated texture stage.
| setTexGen (TextureStage stage, TexGenMode mode, Point3 const constant_value, int priority)
| Enables automatic texture coordinate generation for the indicated texture stage.
| setTexHpr (TextureStage stage, VBase3 const hpr)
| Sets a texture matrix on the current node to apply the indicated rotation, as a 3-D HPR, to UVW's for the given stage.
| setTexHpr (TextureStage stage, float h, float p, float r)
| Sets a texture matrix on the current node to apply the indicated rotation, as a 3-D HPR, to UVW's for the given stage.
| setTexHpr (NodePath const other, TextureStage stage, VBase3 const hpr)
| Sets a texture matrix on the current node to apply the indicated rotation, as a 3-D HPR, to UVW's for the given stage.
| setTexHpr (NodePath const other, TextureStage stage, float h, float p, float r)
| Sets a texture matrix on the current node to apply the indicated rotation, as a 3-D HPR, to UVW's for the given stage.
| setTexOffset (TextureStage stage, VBase2 const uv)
| Sets a texture matrix on the current node to apply the indicated offset to UV's for the given stage.
| setTexOffset (NodePath const other, TextureStage stage, float u, float v)
| Sets a texture matrix on the current node to apply the indicated offset to UV's for the given stage.
| setTexOffset (TextureStage stage, float u, float v)
| Sets a texture matrix on the current node to apply the indicated offset to UV's for the given stage.
| setTexOffset (NodePath const other, TextureStage stage, VBase2 const uv)
| Sets a texture matrix on the current node to apply the indicated offset to UV's for the given stage.
| setTexPos (NodePath const other, TextureStage stage, float u, float v, float w)
| Sets a texture matrix on the current node to apply the indicated offset to UVW's for the given stage.
| setTexPos (TextureStage stage, float u, float v, float w)
| Sets a texture matrix on the current node to apply the indicated offset to UVW's for the given stage.
| setTexPos (TextureStage stage, VBase3 const uvw)
| Sets a texture matrix on the current node to apply the indicated offset to UVW's for the given stage.
| setTexPos (NodePath const other, TextureStage stage, VBase3 const uvw)
| Sets a texture matrix on the current node to apply the indicated offset to UVW's for the given stage.
| setTexProjector (TextureStage stage, NodePath const from, NodePath const to)
| Establishes a TexProjectorEffect on this node, which can be used to establish projective texturing (but see also the NodePath.project_texture() convenience function), or it can be used to bind this node's texture transform to particular node's position in space, allowing a LerpInterval (for instance) to adjust this node's texture coordinates.
| setTexRotate (NodePath const other, TextureStage stage, float r)
| Sets a texture matrix on the current node to apply the indicated rotation, clockwise in degrees, to UV's for the given stage.
| setTexRotate (TextureStage stage, float r)
| Sets a texture matrix on the current node to apply the indicated rotation, clockwise in degrees, to UV's for the given stage.
| setTexScale (TextureStage stage, float su, float sv, float sw)
| Sets a texture matrix on the current node to apply the indicated scale to UVW's for the given stage.
| setTexScale (TextureStage stage, VBase2 const scale)
| Sets a texture matrix on the current node to apply the indicated scale to UV's for the given stage.
| setTexScale (TextureStage stage, float su, float sv)
| Sets a texture matrix on the current node to apply the indicated scale to UV's for the given stage.
| setTexScale (NodePath const other, TextureStage stage, VBase3 const scale)
| Sets a texture matrix on the current node to apply the indicated scale to UVW's for the given stage.
| setTexScale (NodePath const other, TextureStage stage, float su, float sv)
| Sets a texture matrix on the current node to apply the indicated scale to UV's for the given stage.
| setTexScale (NodePath const other, TextureStage stage, float scale)
| Sets a texture matrix on the current node to apply the indicated scale to UV's for the given stage.
| setTexScale (TextureStage stage, float scale)
| Sets a texture matrix on the current node to apply the indicated scale to UVW's for the given stage.
| setTexScale (NodePath const other, TextureStage stage, float su, float sv, float sw)
| Sets a texture matrix on the current node to apply the indicated scale to UVW's for the given stage.
| setTexScale (TextureStage stage, VBase3 const scale)
| Sets a texture matrix on the current node to apply the indicated scale to UVW's for the given stage.
| setTexScale (NodePath const other, TextureStage stage, VBase2 const scale)
| Sets a texture matrix on the current node to apply the indicated scale to UV's for the given stage.
| setTexTransform (TextureStage stage, TransformState const transform)
| Sets the texture matrix on the current node to the indicated transform for the given stage.
| setTexTransform (NodePath const other, TextureStage stage, TransformState const transform)
| Sets the texture matrix on the current node to the indicated transform for the given stage.
| setTexture (Texture tex, int priority)
| Adds the indicated texture to the list of textures that will be rendered on the default texture stage.
| setTexture (TextureStage stage, Texture tex)
| Adds the indicated texture to the list of textures that will be rendered on the indicated multitexture stage.
| setTexture (TextureStage stage, Texture tex, int priority)
| Adds the indicated texture to the list of textures that will be rendered on the indicated multitexture stage.
| setTexture (Texture tex)
| Adds the indicated texture to the list of textures that will be rendered on the default texture stage.
| setTextureOff (TextureStage stage)
| Sets the geometry at this level and below to render using no texture, on the indicated stage.
| setTextureOff ()
| Sets the geometry at this level and below to render using no texture, on any stage.
| setTextureOff (TextureStage stage, int priority)
| Sets the geometry at this level and below to render using no texture, on the indicated stage.
| setTextureOff (int priority)
| Sets the geometry at this level and below to render using no texture, on any stage.
| setTransform (NodePath const other, TransformState const transform)
| Sets the transform object on this node, relative to the other node.
| setTransform (TransformState const transform)
| Changes the complete transform object on this node.
| setTransform (NodePath const other, TransformState const transform, Thread current_thread)
| Sets the transform object on this node, relative to the other node.
| setTransform (TransformState const transform, Thread current_thread)
| Changes the complete transform object on this node.
| setTransparency (Mode mode)
| Specifically sets or disables transparent rendering mode on this particular node.
| setTransparency (Mode mode, int priority)
| Specifically sets or disables transparent rendering mode on this particular node.
| setTwoSided (bool two_sided)
| Specifically sets or disables two-sided rendering mode on this particular node.
| setTwoSided (bool two_sided, int priority)
| Specifically sets or disables two-sided rendering mode on this particular node.
| setX (float x)
| setX (NodePath const other, float x)
| setY (NodePath const other, float y)
| setY (float y)
| setZ (NodePath const other, float z)
| setZ (float z)
| show ()
| Undoes the effect of a previous hide() on this node: makes the referenced node (and the entire subgraph below this node) visible to all cameras.
| show (BitMaskunsigned int, 32 camera_mask)
| Makes the referenced node visible just to the cameras whose camera_mask shares the indicated bits.
| showBounds ()
| Causes the bounding volume of the bottom node and all of its descendants (that is, the bounding volume associated with the the bottom arc) to be rendered, if possible.
| showThrough (BitMaskunsigned int, 32 camera_mask)
| Makes the referenced node visible just to the cameras whose camera_mask shares the indicated bits.
| showThrough ()
| Makes the referenced node visible just to the cameras whose camera_mask shares the indicated bits.
| showTightBounds ()
| Similar to show_bounds(), this draws a bounding box representing the "tight" bounds of this node and all of its descendants.
| stash (int sort)
| Removes the referenced node (and the entire subgraph below this node) from the scene graph in any normal sense.
| stash ()
| Removes the referenced node (and the entire subgraph below this node) from the scene graph in any normal sense.
| stash (int sort, Thread current_thread)
| Removes the referenced node (and the entire subgraph below this node) from the scene graph in any normal sense.
| stashTo (NodePath const other)
| Similar to reparent_to(), but the node is added to its new parent's stashed list, so that the result is equivalent to calling reparent_to() immediately followed by stash().
| stashTo (NodePath const other, int sort, Thread current_thread)
| Similar to reparent_to(), but the node is added to its new parent's stashed list, so that the result is equivalent to calling reparent_to() immediately followed by stash().
| stashTo (NodePath const other, int sort)
| Similar to reparent_to(), but the node is added to its new parent's stashed list, so that the result is equivalent to calling reparent_to() immediately followed by stash().
| unifyTextureStages (TextureStage stage)
| Searches through all TextureStages at this node and below.
| unstash (int sort, Thread current_thread)
| Undoes the effect of a previous stash() on this node: makes the referenced node (and the entire subgraph below this node) once again part of the scene graph.
| unstash ()
| Undoes the effect of a previous stash() on this node: makes the referenced node (and the entire subgraph below this node) once again part of the scene graph.
| unstash (int sort)
| Undoes the effect of a previous stash() on this node: makes the referenced node (and the entire subgraph below this node) once again part of the scene graph.
| unstashAll ()
| Unstashes this node and all stashed child nodes.
| unstashAll (Thread current_thread)
| Unstashes this node and all stashed child nodes.
bool | verifyComplete ()
| Returns true if all of the nodes described in the NodePath are connected, or false otherwise.
bool | verifyComplete (Thread current_thread)
| Returns true if all of the nodes described in the NodePath are connected, or false otherwise.
bool | writeBamFile (Filename const filename)
| Writes the contents of this node and below out to a bam file with the indicated filename.
bool | writeBamStream (ostream out)
| Writes the contents of this node and below out to the indicated stream.
| writeBounds (ostream out)
| Writes a description of the bounding volume containing the bottom node and all of its descendants to the indicated output stream.
| wrtReparentTo (NodePath const other, int sort)
| This functions identically to reparent_to(), except the transform on this node is also adjusted so that the node remains in the same place in world coordinates, even if it is reparented into a different coordinate system.
| wrtReparentTo (NodePath const other)
| This functions identically to reparent_to(), except the transform on this node is also adjusted so that the node remains in the same place in world coordinates, even if it is reparented into a different coordinate system.
| wrtReparentTo (NodePath const other, int sort, Thread current_thread)
| This functions identically to reparent_to(), except the transform on this node is also adjusted so that the node remains in the same place in world coordinates, even if it is reparented into a different coordinate system.
## Static Public Member Functions
static NodePath | anyPath (PandaNode node, Thread current_thread)
| Returns a new NodePath that represents any arbitrary path from the root to the indicated node.
static NodePath | anyPath (PandaNode node)
| Returns a new NodePath that represents any arbitrary path from the root to the indicated node.
static NodePath | decodeFromBamStream (string data, BamReader reader)
| Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the NodePath on that string.
static NodePath | decodeFromBamStream (string data)
| Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the NodePath on that string.
static NodePath | fail ()
| Creates a NodePath with the ET_fail error type set.
static TypeHandle | getClassType ()
static int | getMaxSearchDepth ()
| Returns the current setting of the search depth limit.
static NodePath | notFound ()
| Creates a NodePath with the ET_not_found error type set.
static NodePath | removed ()
| Creates a NodePath with the ET_removed error type set.
static | setMaxSearchDepth (int max_search_depth)
| Certain operations, such as find() or find_all_matches(), require a traversal of the scene graph to search for the target node or nodes.
## Public Attributes
BitMaskunsigned | int
| Returns the union of all of the into_collide_masks for nodes at this level and below.

## Detailed Description

NodePath is the fundamental system for disambiguating instances, and also provides a higher-level interface for manipulating the scene graph.

A NodePath is a list of connected nodes from the root of the graph to any sub-node. Each NodePath therefore uniquely describes one instance of a node.

NodePaths themselves are lightweight objects that may easily be copied and passed by value. Their data is stored as a series of NodePathComponents that are stored on the nodes. Holding a NodePath will keep a reference count to all the nodes in the path. However, if any node in the path is removed or reparented (perhaps through a different NodePath), the NodePath will automatically be updated to reflect the changes.

## Member Enumeration Documentation

enum ErrorType

Enumerator:

  ETOk |
  ETNotFound |
  ETRemoved |
  ETFail |

## Constructor & Destructor Documentation

NodePath | ( |  | ) |

This constructs an empty NodePath with no nodes.

NodePath | ( | NodePath const | copy | ) |

NodePath | ( | NodePath const | parent,
|  | PandaNode | child_node,
|  | Thread | current_thread
| ) |  |

Constructs a NodePath with the indicated parent NodePath and child node; the child node must be a stashed or unstashed child of the parent.

NodePath | ( | NodePath const | parent,
|  | PandaNode | child_node
| ) |  |

Constructs a NodePath with the indicated parent NodePath and child node; the child node must be a stashed or unstashed child of the parent.

NodePath | ( | PandaNode | node,
|  | Thread | current_thread
| ) |  |

This constructs a NodePath for the indicated node.

If the node does not have any parents, this creates a singleton NodePath; otherwise, it automatically finds the path from the node to the root. If the node has multiple paths to the root, one path is chosen arbitrarily and a warning message is printed (but see also NodePath.any_path(), below).

NodePath | ( | PandaNode | node | ) |

This constructs a NodePath for the indicated node.

If the node does not have any parents, this creates a singleton NodePath; otherwise, it automatically finds the path from the node to the root. If the node has multiple paths to the root, one path is chosen arbitrarily and a warning message is printed (but see also NodePath.any_path(), below).

NodePath | ( | string | top_node_name,
|  | Thread | current_thread
| ) |  |

This constructs a new NodePath with a single node.

An ordinary, unattached PandaNode is created with the indicated name.

NodePath | ( | string | top_node_name | ) |

This constructs a new NodePath with a single node.

An ordinary, unattached PandaNode is created with the indicated name.

## Member Function Documentation

unsigned int addHash | ( | unsigned int | hash | ) |

Adds the NodePath into the running hash.

This is intended to be used by lower-level code that computes a hash for each NodePath. It modifies the hash value passed in by a unique adjustment for each NodePath, and returns the modified hash.

This is similar to the unique integer returned by get_key(), but it is not guaranteed to remain unique beyond the lifetime of this particular NodePath. Once this NodePath destructs, a different NodePath may be created which shares the same hash value.

adjustAllPriorities | ( | int | adjustment | ) |

Adds the indicated adjustment amount (which may be negative) to the priority for all transitions on the referenced node, and for all nodes in the subgraph below.

This can be used to force these nodes not to be overridden by a high-level state change above. If the priority would drop below zero, it is set to zero.

static NodePath anyPath | ( | PandaNode | node | ) | `[static]`

Returns a new NodePath that represents any arbitrary path from the root to the indicated node.

This is the same thing that would be returned by NodePath(node), except that no warning is issued if the path is ambiguous.

static NodePath anyPath | ( | PandaNode | node,
|  | Thread | current_thread
| ) |  | `[static]`

Returns a new NodePath that represents any arbitrary path from the root to the indicated node.

This is the same thing that would be returned by NodePath(node), except that no warning is issued if the path is ambiguous.

applyTextureColors | ( |  | ) |

Removes textures from Geoms at this node and below by applying the texture colors to the vertices.

This is primarily useful to simplify a low-LOD model. The texture colors are replaced by flat colors that approximate the original textures.

Only the bottommost texture on each Geom is used (if there is more than one), and it is applied as if it were M_modulate, and WM_repeat, regardless of its actual settings. If the texture has a simple_ram_image, this may be used if the main image isn't resident.

After this call, there will be no texturing specified at this level and below. Of course, there might still be texturing inherited from above.

NodePath attachNewNode | ( | PandaNode | node,
|  | int | sort,
|  | Thread | current_thread
| ) |  |

Attaches a new node, with or without existing parents, to the scene graph below the referenced node of this NodePath.

This is the preferred way to add nodes to the graph.

If the node was already a child of the parent, this returns a NodePath to the existing child.

This does *not* automatically extend the current NodePath to reflect the attachment; however, a NodePath that does reflect this extension is returned.

NodePath attachNewNode | ( | PandaNode | node | ) |

Attaches a new node, with or without existing parents, to the scene graph below the referenced node of this NodePath.

This is the preferred way to add nodes to the graph.

If the node was already a child of the parent, this returns a NodePath to the existing child.

This does *not* automatically extend the current NodePath to reflect the attachment; however, a NodePath that does reflect this extension is returned.

NodePath attachNewNode | ( | PandaNode | node,
|  | int | sort
| ) |  |

Attaches a new node, with or without existing parents, to the scene graph below the referenced node of this NodePath.

This is the preferred way to add nodes to the graph.

If the node was already a child of the parent, this returns a NodePath to the existing child.

This does *not* automatically extend the current NodePath to reflect the attachment; however, a NodePath that does reflect this extension is returned.

NodePath attachNewNode | ( | string | name,
|  | int | sort,
|  | Thread | current_thread
| ) |  |

Creates an ordinary PandaNode and attaches it below the current NodePath, returning a new NodePath that references it.

NodePath attachNewNode | ( | string | name,
|  | int | sort
| ) |  |

Creates an ordinary PandaNode and attaches it below the current NodePath, returning a new NodePath that references it.

NodePath attachNewNode | ( | string | name | ) |

Creates an ordinary PandaNode and attaches it below the current NodePath, returning a new NodePath that references it.

bool calcTightBounds | ( | Point3 | min_point,
|  | Point3 | max_point,
|  | Thread | current_thread
| ) |  |

Calculates the minimum and maximum vertices of all Geoms at this NodePath's bottom node and below.

This is a tight bounding box; it will generally be tighter than the bounding volume returned by get_bounds() (but it is more expensive to compute).

The return value is true if any points are within the bounding volume, or false if none are.

bool calcTightBounds | ( | Point3 | min_point,
|  | Point3 | max_point
| ) |  |

Calculates the minimum and maximum vertices of all Geoms at this NodePath's bottom node and below.

This is a tight bounding box; it will generally be tighter than the bounding volume returned by get_bounds() (but it is more expensive to compute).

The return value is true if any points are within the bounding volume, or false if none are.

clearAntialias | ( |  | ) |

Completely removes any antialias setting that may have been set on this node via set_antialias().

clearAttrib | ( | TypeHandle | type | ) |

Removes the render attribute of the given type from this node.

This node, and the subgraph below, will now inherit the indicated render attribute from the nodes above this one.

clearAudioVolume | ( |  | ) |

Completely removes any audio volume from the referenced node.

This is preferable to simply setting the audio volume to identity, as it also removes the overhead associated with having an audio volume at all.

clearBillboard | ( |  | ) |

Removes any billboard effect from the node.

clearBin | ( |  | ) |

Completely removes any bin adjustment that may have been set via set_bin() from this particular node.

clearClipPlane | ( |  | ) |

Completely removes any clip planes that may have been set via set_clip_plane() or set_clip_plane_off() from this particular node.

clearClipPlane | ( | NodePath const | clip_plane | ) |

Removes any reference to the indicated clipping plane from the NodePath.

clearColor | ( |  | ) |

Completely removes any color adjustment from the node.

This allows the natural color of the geometry, or whatever color transitions might be otherwise affecting the geometry, to show instead.

clearColorScale | ( |  | ) |

Completely removes any color scale from the referenced node.

This is preferable to simply setting the color scale to identity, as it also removes the overhead associated with having a color scale at all.

clearCompass | ( |  | ) |

Removes any compass effect from the node.

clearDepthOffset | ( |  | ) |

Completely removes any depth-offset adjustment that may have been set on this node via set_depth_offset().

clearDepthTest | ( |  | ) |

Completely removes any depth-test adjustment that may have been set on this node via set_depth_test().

clearDepthWrite | ( |  | ) |

Completely removes any depth-write adjustment that may have been set on this node via set_depth_write().

clearEffect | ( | TypeHandle | type | ) |

Removes the render effect of the given type from this node.

clearEffects | ( |  | ) |

Resets this node to have no render effects.

clearFog | ( |  | ) |

Completely removes any fog adjustment that may have been set via set_fog() or set_fog_off() from this particular node.

This allows whatever fogs might be otherwise affecting the geometry to show instead.

clearLight | ( |  | ) |

Completely removes any lighting operations that may have been set via set_light() or set_light_off() from this particular node.

clearLight | ( | NodePath const | light | ) |

Removes any reference to the indicated Light or PolylightNode from the NodePath.

clearMat | ( |  | ) |

Completely removes any transform from the referenced node.

clearMaterial | ( |  | ) |

Completely removes any material adjustment that may have been set via set_material() from this particular node.

int clearModelNodes | ( |  | ) |

Recursively walks through the scene graph at this level and below, looking for ModelNodes, and calls model_node->set_preserve_transform(PT_drop_node) on each one.

This allows a subsequent call to flatten_strong() to eliminate all of the ModelNodes.

Returns the number of ModelNodes found.

clearNormalMap | ( |  | ) |

Undoes the effect of a previous call to set_normal_map().

clearOccluder | ( |  | ) |

Completely removes any occluders that may have been set via set_occluder() from this particular node.

clearOccluder | ( | NodePath const | occluder | ) |

Removes any reference to the indicated occluder from the NodePath.

clearProjectTexture | ( | TextureStage | stage | ) |

Undoes the effect of project_texture().

clearPythonTag | ( | string | key | ) |

Removes the Python object defined for this key on this particular node.

After a call to clear_python_tag(), has_python_tag() will return false for the indicated key.

clearRenderMode | ( |  | ) |

Completely removes any render mode adjustment that may have been set on this node via set_render_mode_wireframe() or set_render_mode_filled().

clearScissor | ( |  | ) |

Removes the scissor region that was defined at this node level by a previous call to set_scissor().

clearShader | ( |  | ) |

clearShaderInput | ( | InternalName const | id | ) |

clearShaderInput | ( | string | id | ) |

clearTag | ( | string | key | ) |

Removes the value defined for this key on this particular node.

After a call to clear_tag(), has_tag() will return false for the indicated key.

clearTexGen | ( |  | ) |

Removes the texture coordinate generation mode from all texture stages on this node.

clearTexGen | ( | TextureStage | stage | ) |

Disables automatic texture coordinate generation for the indicated texture stage.

clearTexProjector | ( |  | ) |

Removes the TexProjectorEffect for all stages from this node.

clearTexProjector | ( | TextureStage | stage | ) |

Removes the TexProjectorEffect for the indicated stage from this node.

clearTexTransform | ( |  | ) |

Removes all texture matrices from the current node.

clearTexTransform | ( | TextureStage | stage | ) |

Removes the texture matrix on the current node for the given stage.

clearTexture | ( | TextureStage | stage | ) |

Removes any reference to the indicated texture stage from the NodePath.

clearTexture | ( |  | ) |

Completely removes any texture adjustment that may have been set via set_texture() or set_texture_off() from this particular node.

This allows whatever textures might be otherwise affecting the geometry to show instead.

clearTransform | ( | NodePath const | other | ) |

Sets the transform object on this node to identity, relative to the other node.

This effectively places this node at the same position as the other node.

clearTransform | ( | Thread | current_thread | ) |

Sets the transform object on this node to identity.

clearTransform | ( |  | ) |

Sets the transform object on this node to identity.

clearTransform | ( | NodePath const | other,
|  | Thread | current_thread
| ) |  |

Sets the transform object on this node to identity, relative to the other node.

This effectively places this node at the same position as the other node.

clearTransparency | ( |  | ) |

Completely removes any transparency adjustment that may have been set on this node via set_transparency().

The geometry at this level and below will subsequently be rendered either transparent or not, to whatever other nodes may have had set_transparency() on them.

clearTwoSided | ( |  | ) |

Completely removes any two-sided adjustment that may have been set on this node via set_two_sided().

The geometry at this level and below will subsequently be rendered either two-sided or one-sided, according to whatever other nodes may have had set_two_sided() on it, or according to the initial state otherwise.

int compareTo | ( | NodePath const | other | ) |

Returns a number less than zero if this NodePath sorts before the other one, greater than zero if it sorts after, or zero if they are equivalent.

Two NodePaths are considered equivalent if they consist of exactly the same list of nodes in the same order. Otherwise, they are different; different NodePaths will be ranked in a consistent but undefined ordering; the ordering is useful only for placing the NodePaths in a sorted container like an STL set.

composeColorScale | ( | VBase4 const | scale,
|  | int | priority
| ) |  |

multiplies the color scale component of the transform, with previous color scale leaving translation and rotation untouched.

composeColorScale | ( | VBase4 const | scale | ) |

multiplies the color scale component of the transform, with previous color scale leaving translation and rotation untouched.

composeColorScale | ( | float | sx,
|  | float | sy,
|  | float | sz,
|  | float | sa,
|  | int | priority
| ) |  |

Sets the color scale component of the transform.

composeColorScale | ( | float | sx,
|  | float | sy,
|  | float | sz,
|  | float | sa
| ) |  |

Sets the color scale component of the transform.

NodePath copy | ( |  | ) |

A special Python method that is invoked by copy.copy(node).

Unlike the NodePath copy constructor, this makes a duplicate copy of the underlying PandaNode (but shares children, instead of copying them or omitting them).

NodePath copyTo | ( | NodePath const | other,
|  | int | sort
| ) |  |

Functions like instance_to(), except a deep copy is made of the referenced node and all of its descendents, which is then parented to the indicated node.

A NodePath to the newly created copy is returned.

NodePath copyTo | ( | NodePath const | other,
|  | int | sort,
|  | Thread | current_thread
| ) |  |

Functions like instance_to(), except a deep copy is made of the referenced node and all of its descendents, which is then parented to the indicated node.

A NodePath to the newly created copy is returned.

NodePath copyTo | ( | NodePath const | other | ) |

Functions like instance_to(), except a deep copy is made of the referenced node and all of its descendents, which is then parented to the indicated node.

A NodePath to the newly created copy is returned.

int countNumDescendants | ( |  | ) |

Returns the number of nodes at and below this level.

static NodePath decodeFromBamStream | ( | string | data,
|  | BamReader | reader
| ) |  | `[static]`

Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the NodePath on that string.

Returns NULL on error.

static NodePath decodeFromBamStream | ( | string | data | ) | `[static]`

Reads the string created by a previous call to encode_to_bam_stream(), and extracts and returns the NodePath on that string.

Returns NULL on error.

PyObject deepcopy | ( | PyObject | self,
|  | PyObject | memo
| ) |  |

A special Python method that is invoked by copy.deepcopy(np).

This calls copy_to() unless the NodePath is already present in the provided dictionary.

detachNode | ( | Thread | current_thread | ) |

Disconnects the referenced node from its parent, but does not immediately delete it.

The NodePath retains a pointer to the node, and becomes a singleton NodePath.

This should be called to detach a node from the scene graph, with the option of reattaching it later to the same parent or to a different parent.

In practice, the only difference between remove_node() and detach_node() is that remove_node() also resets the NodePath to empty, which will cause the node to be deleted immediately if there are no other references. On the other hand, detach_node() leaves the NodePath referencing the node, which will keep at least one reference to the node for as long as the NodePath exists.

detachNode | ( |  | ) |

Disconnects the referenced node from its parent, but does not immediately delete it.

The NodePath retains a pointer to the node, and becomes a singleton NodePath.

This should be called to detach a node from the scene graph, with the option of reattaching it later to the same parent or to a different parent.

In practice, the only difference between remove_node() and detach_node() is that remove_node() also resets the NodePath to empty, which will cause the node to be deleted immediately if there are no other references. On the other hand, detach_node() leaves the NodePath referencing the node, which will keep at least one reference to the node for as long as the NodePath exists.

doBillboardAxis | ( | NodePath const | camera,
|  | float | offset
| ) |  |

Performs a billboard-type rotate to the indicated camera node, one time only, and leaves the object rotated.

This is similar in principle to heads_up().

doBillboardPointEye | ( | NodePath const | camera,
|  | float | offset
| ) |  |

Performs a billboard-type rotate to the indicated camera node, one time only, and leaves the object rotated.

This is similar in principle to look_at(), although the point_eye billboard effect cannot be achieved using the ordinary look_at() call.

doBillboardPointWorld | ( | NodePath const | camera,
|  | float | offset
| ) |  |

Performs a billboard-type rotate to the indicated camera node, one time only, and leaves the object rotated.

This is similar in principle to look_at().

bool encodeToBamStream | ( | basic_stringchar | data | ) |

Converts the NodePath object into a single stream of data using a BamWriter, and stores that data in the indicated string.

Returns true on success, false on failure.

If the BamWriter is NULL, this behaves the same way as NodePath.write_bam_stream() and PandaNode.encode_to_bam_stream(), in the sense that it only writes this node and all nodes below it.

However, if the BamWriter is not NULL, it behaves very differently. In this case, it encodes the entire graph* of all nodes connected to the NodePath, including all parent nodes and siblings. This is necessary for correct streaming of related NodePaths and restoration of instances, etc., but it does mean you must detach() a node before writing it if you want to limit the nodes that get written.

This method is used by __reduce__ to handle streaming of NodePaths to a pickle file. The BamWriter case is used by the direct.stdpy.pickle module, while the saner, non-BamWriter case is used when the standard pickle module calls this function.

string encodeToBamStream | ( |  | ) |

Converts the NodePath object into a single stream of data using a BamWriter, and returns that data as a string string.

Returns empty string on failure. This is similar to write_bam_stream().

This method is used by __reduce__ to handle streaming of NodePaths to a pickle file.

bool encodeToBamStream | ( | basic_stringchar | data,
|  | BamWriter | writer
| ) |  |

Converts the NodePath object into a single stream of data using a BamWriter, and stores that data in the indicated string.

Returns true on success, false on failure.

If the BamWriter is NULL, this behaves the same way as NodePath.write_bam_stream() and PandaNode.encode_to_bam_stream(), in the sense that it only writes this node and all nodes below it.

However, if the BamWriter is not NULL, it behaves very differently. In this case, it encodes the entire graph* of all nodes connected to the NodePath, including all parent nodes and siblings. This is necessary for correct streaming of related NodePaths and restoration of instances, etc., but it does mean you must detach() a node before writing it if you want to limit the nodes that get written.

This method is used by __reduce__ to handle streaming of NodePaths to a pickle file. The BamWriter case is used by the direct.stdpy.pickle module, while the saner, non-BamWriter case is used when the standard pickle module calls this function.

static NodePath fail | ( |  | ) | `[static]`

Creates a NodePath with the ET_fail error type set.

NodePath find | ( | string | path | ) |

Searches for a node below the referenced node that matches the indicated string.

Returns the shortest match found, if any, or an empty NodePath if no match can be found.

NodePathCollection findAllMatches | ( | string | path | ) |

Returns the complete set of all NodePaths that begin with this NodePath and can be extended by path.

The shortest paths will be listed first.

MaterialCollection findAllMaterials | ( | string | name | ) |

Returns a list of a materials applied to geometry at this node and below that match the indicated name (which may contain wildcard characters).

MaterialCollection findAllMaterials | ( |  | ) |

Returns a list of a materials applied to geometry at this node and below.

NodePathCollection findAllPathsTo | ( | PandaNode | node | ) |

Returns the set of all NodePaths that extend from this NodePath down to the indicated node.

The shortest paths will be listed first.

InternalNameCollection findAllTexcoords | ( | string | name | ) |

Returns a list of all texture coordinate sets used by any geometry at this node level and below that match the indicated name (which may contain wildcard characters).

InternalNameCollection findAllTexcoords | ( |  | ) |

Returns a list of all texture coordinate sets used by any geometry at this node level and below.

TextureCollection findAllTextures | ( |  | ) |

Returns a list of a textures applied to geometry at this node and below.

TextureCollection findAllTextures | ( | TextureStage | stage | ) |

Returns a list of a textures on geometry at this node and below that are assigned to the indicated texture stage.

TextureCollection findAllTextures | ( | string | name | ) |

Returns a list of a textures applied to geometry at this node and below that match the indicated name (which may contain wildcard characters).

TextureStageCollection findAllTextureStages | ( |  | ) |

Returns a list of a TextureStages applied to geometry at this node and below.

TextureStageCollection findAllTextureStages | ( | string | name | ) |

Returns a list of a TextureStages applied to geometry at this node and below that match the indicated name (which may contain wildcard characters).

InternalNameCollection findAllVertexColumns | ( |  | ) |

Returns a list of all vertex array columns stored on some geometry found at this node level and below.

InternalNameCollection findAllVertexColumns | ( | string | name | ) |

Returns a list of all vertex array columns stored on some geometry found at this node level and below that match the indicated name (which may contain wildcard characters).

Material findMaterial | ( | string | name | ) |

Returns the first material found applied to geometry at this node or below that matches the indicated name (which may contain wildcards).

Returns the material if it is found, or NULL if it is not.

NodePath findNetPythonTag | ( | string | key | ) |

Returns the lowest ancestor of this node that contains a tag definition with the indicated key, if any, or an empty NodePath if no ancestor of this node contains this tag definition.

See set_python_tag().

NodePath findNetTag | ( | string | key | ) |

Returns the lowest ancestor of this node that contains a tag definition with the indicated key, if any, or an empty NodePath if no ancestor of this node contains this tag definition.

See set_tag().

NodePath findPathTo | ( | PandaNode | node | ) |

Searches for the indicated node below this node and returns the shortest NodePath that connects them.

Texture findTexture | ( | TextureStage | stage | ) |

Returns the first texture found applied to geometry at this node or below that is assigned to the indicated texture stage.

Returns the texture if it is found, or NULL if it is not.

Texture findTexture | ( | string | name | ) |

Returns the first texture found applied to geometry at this node or below that matches the indicated name (which may contain wildcards).

Returns the texture if it is found, or NULL if it is not.

TextureStage findTextureStage | ( | string | name | ) |

Returns the first TextureStage found applied to geometry at this node or below that matches the indicated name (which may contain wildcards).

Returns the TextureStage if it is found, or NULL if it is not.

int flattenLight | ( |  | ) |

Lightly flattens out the hierarchy below this node by applying transforms, colors, and texture matrices from the nodes onto the vertices, but does not remove any nodes.

This can result in improved rendering performance because there will be fewer transforms in the resulting scene graph, but the number of nodes will remain the same.

In particular, any NodePaths that reference nodes within this hierarchy will not be damaged. However, since this operation will remove transforms from the scene graph, it may be dangerous to apply to nodes where you expect to dynamically modify the transform, or where you expect the geometry to remain in a particular local coordinate system.

The return value is always 0, since flatten_light does not remove any nodes.

int flattenMedium | ( |  | ) |

A more thorough flattening than flatten_light(), this first applies all the transforms, colors, and texture matrices from the nodes onto the vertices, and then removes unneeded grouping nodes--nodes that have exactly one child, for instance, but have no special properties in themselves.

This results in improved performance over flatten_light() because the number of nodes in the scene graph is reduced.

The return value is the number of nodes removed.

int flattenStrong | ( |  | ) |

The strongest possible flattening.

This first applies all of the transforms to the vertices, as in flatten_medium(), but then it will combine sibling nodes together when possible, in addition to removing unnecessary parent-child nodes. This can result in substantially fewer nodes, but any nicely-grouped hierachical bounding volumes may be lost.

It is generally a good idea to apply this kind of flattening only to nodes that will be culled largely as a single unit, like a car. Applying this to an entire scene may result in overall poorer performance because of less-effective culling.

forceRecomputeBounds | ( |  | ) |

Forces the recomputing of all the bounding volumes at every node in the subgraph beginning at this node and below.

This should not normally need to be called, since the bounding volumes are supposed to be recomputed automatically when necessary. It may be useful when debugging, to verify that the bounding volumes have not become inadvertently stale; it may also be useful to force animated characters to update their bounding volumes (which does not presently happen automatically).

NodePath getAncestor | ( | int | index,
|  | Thread | current_thread
| ) |  |

Returns the nth ancestor of the path, where 0 is the NodePath itself and get_num_nodes() - 1 is get_top().

This requires iterating through the path.

Also see get_node(), which returns the same thing as a PandaNode pointer, not a NodePath.

NodePath getAncestor | ( | int | index | ) |

Returns the nth ancestor of the path, where 0 is the NodePath itself and get_num_nodes() - 1 is get_top().

This requires iterating through the path.

Also see get_node(), which returns the same thing as a PandaNode pointer, not a NodePath.

list getAncestors | ( |  | ) |

unsigned short int getAntialias | ( |  | ) |

Returns the antialias setting that has been specifically set on this node via set_antialias(), or M_none if no setting has been made.

RenderAttrib const getAttrib | ( | TypeHandle | type | ) |

Returns the render attribute of the indicated type, if it is defined on the node, or NULL if it is not.

This checks only what is set on this particular node level, and has nothing to do with what render attributes may be inherited from parent nodes.

float getAudioVolume | ( |  | ) |

Returns the complete audio volume that has been applied to this node via a previous call to set_audio_volume(), or 1.

(identity) if no volume has been applied to this particular node.

int getBinDrawOrder | ( |  | ) |

Returns the drawing order associated with the bin that this particular node was assigned to via set_bin(), or 0 if no bin was assigned.

See set_bin() and has_bin().

string getBinName | ( |  | ) |

Returns the name of the bin that this particular node was assigned to via set_bin(), or the empty string if no bin was assigned.

See set_bin() and has_bin().

BoundingVolume getBounds | ( | Thread | current_thread | ) |

Returns a newly-allocated bounding volume containing the bottom node and all of its descendants.

This is the bounding volume on the bottom arc, converted to the local coordinate space of the node.

BoundingVolume getBounds | ( |  | ) |

Returns a newly-allocated bounding volume containing the bottom node and all of its descendants.

This is the bounding volume on the bottom arc, converted to the local coordinate space of the node.

NodePath getChild | ( | int | n,
|  | Thread | current_thread
| ) |  |

Returns a NodePath representing the nth child of the referenced node.

NodePath getChild | ( | int | n | ) |

Returns a NodePath representing the nth child of the referenced node.

NodePathCollection getChildren | ( | Thread | current_thread | ) |

Returns the set of all child nodes of the referenced node.

NodePathCollection getChildren | ( |  | ) |

Returns the set of all child nodes of the referenced node.

static TypeHandle getClassType | ( |  | ) | `[static]`

BitMaskunsigned getCollideMask | ( |  | ) |

VBase4 getColor | ( |  | ) |

Returns the color that has been assigned to the node, or black if no color has been assigned.

VBase4 const getColorScale | ( |  | ) |

Returns the complete color scale vector that has been applied to this node via a previous call to set_color_scale() and/or set_alpha_scale(), or all 1's (identity) if no scale has been applied to this particular node.

NodePath getCommonAncestor | ( | NodePath const | other,
|  | Thread | current_thread
| ) |  |

Returns the lowest NodePath that both of these two NodePaths have in common: the first ancestor that both of them share.

If the two NodePaths are unrelated, returns NodePath.not_found().

NodePath getCommonAncestor | ( | NodePath const | other | ) |

Returns the lowest NodePath that both of these two NodePaths have in common: the first ancestor that both of them share.

If the two NodePaths are unrelated, returns NodePath.not_found().

int getDepthOffset | ( |  | ) |

Returns the depth offset value if it has been specified using set_depth_offset, or 0 if not.

bool getDepthTest | ( |  | ) |

Returns true if depth-test rendering has been specifically set on this node via set_depth_test(), or false if depth-test rendering has been specifically disabled.

If nothing has been specifically set, returns true. See also has_depth_test().

bool getDepthWrite | ( |  | ) |

Returns true if depth-write rendering has been specifically set on this node via set_depth_write(), or false if depth-write rendering has been specifically disabled.

If nothing has been specifically set, returns true. See also has_depth_write().

float getDistance | ( | NodePath const | other | ) |

Returns the straight-line distance between this referenced node's coordinate frame's origin, and that of the other node's origin.

RenderEffect const getEffect | ( | TypeHandle | type | ) |

Returns the render effect of the indicated type, if it is defined on the node, or NULL if it is not.

RenderEffects const getEffects | ( |  | ) |

Returns the complete RenderEffects that will be applied to this node.

ErrorType getErrorType | ( |  | ) |

If is_empty() is true, this returns a code that represents the reason why the NodePath is empty.

Fog getFog | ( |  | ) |

Returns the fog that has been set on this particular node, or NULL if no fog has been set.

This is not necessarily the fog that will be applied to the geometry at or below this level, as another fog at a higher or lower level may override.

float getH | ( |  | ) |

float getH | ( | NodePath const | other | ) |

NodePath getHiddenAncestor | ( | BitMaskunsigned | int,
|  | 32 | camera_mask,
|  | Thread | current_thread
| ) |  |

Returns the NodePath at or above the referenced node that is hidden to the indicated camera(s), or an empty NodePath if no ancestor of the referenced node is hidden (and the node should be visible).

NodePath getHiddenAncestor | ( | BitMaskunsigned | int,
|  | 32 | camera_mask
| ) |  |

Returns the NodePath at or above the referenced node that is hidden to the indicated camera(s), or an empty NodePath if no ancestor of the referenced node is hidden (and the node should be visible).

NodePath getHiddenAncestor | ( |  | ) |

Returns the NodePath at or above the referenced node that is hidden to the indicated camera(s), or an empty NodePath if no ancestor of the referenced node is hidden (and the node should be visible).

VBase3 getHpr | ( | NodePath const | other | ) |

Returns the relative orientation of the bottom node as seen from the other node.

VBase3 getHpr | ( |  | ) |

Retrieves the rotation component of the transform.

int getInstanceCount | ( |  | ) |

Returns the geometry instance count, or 0 if disabled.

See set_instance_count.

int getKey | ( |  | ) |

Returns an integer that is guaranteed to be the same for all NodePaths that represent the same node instance, and different for all NodePaths that represent a different node instance.

The same key will be returned for a particular instance as long as at least one NodePath exists that represents that instance; if all NodePaths for a particular instance destruct and a new one is later created, it may have a different index. However, a given key will never be reused for a different instance (unless the app has been running long enough that we overflow the integer key value).

Mat4 const getMat | ( |  | ) |

Returns the transform matrix that has been applied to the referenced node, or the identity matrix if no matrix has been applied.

Mat4 getMat | ( | NodePath const | other | ) |

Returns the matrix that describes the coordinate space of the bottom node, relative to the other path's bottom node's coordinate space.

Material getMaterial | ( |  | ) |

Returns the material that has been set on this particular node, or NULL if no material has been set.

This is not necessarily the material that will be applied to the geometry at or below this level, as another material at a higher or lower level may override. See also find_material().

static int getMaxSearchDepth | ( |  | ) | `[static]`

Returns the current setting of the search depth limit.

See set_max_search_depth.

string getName | ( |  | ) |

Returns the name of the referenced node.

float getNetAudioVolume | ( |  | ) |

Returns the complete audio volume for this node taking highers nodes in the graph into account.

TransformState const getNetPrevTransform | ( | Thread | current_thread | ) |

Returns the net "previous" transform on this node from the root.

See set_prev_transform().

TransformState const getNetPrevTransform | ( |  | ) |

Returns the net "previous" transform on this node from the root.

See set_prev_transform().

PyObject getNetPythonTag | ( | string | key | ) |

Returns the Python object that has been defined on this node, or the nearest ancestor node, for the indicated key.

If no value has been defined for the indicated key on any ancestor node, returns None. See also get_python_tag().

RenderState const getNetState | ( |  | ) |

Returns the net state on this node from the root.

RenderState const getNetState | ( | Thread | current_thread | ) |

Returns the net state on this node from the root.

string getNetTag | ( | string | key | ) |

Returns the tag value that has been defined on this node, or the nearest ancestor node, for the indicated key.

If no value has been defined for the indicated key on any ancestor node, returns the empty string. See also get_tag().

TransformState const getNetTransform | ( |  | ) |

Returns the net transform on this node from the root.

TransformState const getNetTransform | ( | Thread | current_thread | ) |

Returns the net transform on this node from the root.

PandaNode getNode | ( | int | index,
|  | Thread | current_thread
| ) |  |

Returns the nth node of the path, where 0 is the referenced (bottom) node and get_num_nodes() - 1 is the top node.

This requires iterating through the path.

Also see node(), which is a convenience function to return the same thing as get_node(0) (since the bottom node is the most important node in the NodePath, and is the one most frequently referenced).

Note that this function returns the same thing as get_ancestor(index).node().

PandaNode getNode | ( | int | index | ) |

Returns the nth node of the path, where 0 is the referenced (bottom) node and get_num_nodes() - 1 is the top node.

This requires iterating through the path.

Also see node(), which is a convenience function to return the same thing as get_node(0) (since the bottom node is the most important node in the NodePath, and is the one most frequently referenced).

Note that this function returns the same thing as get_ancestor(index).node().

list getNodes | ( |  | ) |

int getNumChildren | ( | Thread | current_thread | ) |

Returns the number of children of the referenced node.

int getNumChildren | ( |  | ) |

Returns the number of children of the referenced node.

int getNumNodes | ( |  | ) |

Returns the number of nodes in the path.

int getNumNodes | ( | Thread | current_thread | ) |

Returns the number of nodes in the path.

float getP | ( |  | ) |

float getP | ( | NodePath const | other | ) |

NodePath getParent | ( | Thread | current_thread | ) |

Returns the NodePath to the parent of the referenced node: that is, this NodePath, shortened by one node.

The parent of a singleton NodePath is defined to be the empty NodePath.

NodePath getParent | ( |  | ) |

Returns the NodePath to the parent of the referenced node: that is, this NodePath, shortened by one node.

The parent of a singleton NodePath is defined to be the empty NodePath.

Point3 getPos | ( |  | ) |

Retrieves the translation component of the transform.

Point3 getPos | ( | NodePath const | other | ) |

Returns the relative position of the referenced node as seen from the other node.

Vec3 getPosDelta | ( |  | ) |

Returns the delta vector from this node's position in the previous frame (according to set_prev_transform(), typically set via the use of set_fluid_pos()) and its position in the current frame.

This is the vector used to determine collisions. Generally, if the node was last repositioned via set_pos(), the delta will be zero; if it was adjusted via set_fluid_pos(), the delta will represent the change from the previous frame's position.

Vec3 getPosDelta | ( | NodePath const | other | ) |

Returns the delta vector from this node's position in the previous frame (according to set_prev_transform(), typically set via the use of set_fluid_pos()) and its position in the current frame, as seen in the indicated node's coordinate space.

This is the vector used to determine collisions. Generally, if the node was last repositioned via set_pos(), the delta will be zero; if it was adjusted via set_fluid_pos(), the delta will represent the change from the previous frame's position.

TransformState const getPrevTransform | ( |  | ) |

Returns the transform that has been set as this node's "previous" position.

See set_prev_transform().

TransformState const getPrevTransform | ( | Thread | current_thread | ) |

Returns the transform that has been set as this node's "previous" position.

See set_prev_transform().

TransformState const getPrevTransform | ( | NodePath const | other,
|  | Thread | current_thread
| ) |  |

Returns the relative "previous" transform to this node from the other node; i.e.

the position of this node in the previous frame, as seen by the other node in the previous frame.

TransformState const getPrevTransform | ( | NodePath const | other | ) |

Returns the relative "previous" transform to this node from the other node; i.e.

the position of this node in the previous frame, as seen by the other node in the previous frame.

PyObject getPythonTag | ( | string | key | ) |

Retrieves the Python object that was previously set on this node for the particular key, if any.

If no object has been previously set, returns None. See also get_net_python_tag().

Quat getQuat | ( |  | ) |

Retrieves the rotation component of the transform.

Quat getQuat | ( | NodePath const | other | ) |

Returns the relative orientation of the bottom node as seen from the other node.

float getR | ( |  | ) |

float getR | ( | NodePath const | other | ) |

Point3 getRelativePoint | ( | NodePath const | other,
|  | VBase3 const | point
| ) |  |

Given that the indicated point is in the coordinate system of the other node, returns the same point in this node's coordinate system.

Vec3 getRelativeVector | ( | NodePath const | other,
|  | VBase3 const | vec
| ) |  |

Given that the indicated vector is in the coordinate system of the other node, returns the same vector in this node's coordinate system.

Mode getRenderMode | ( |  | ) |

Returns the render mode that has been specifically set on this node via set_render_mode(), or M_unchanged if nothing has been set.

bool getRenderModePerspective | ( |  | ) |

Returns the flag that has been set on this node via set_render_mode_perspective(), or false if no flag has been set.

float getRenderModeThickness | ( |  | ) |

Returns the render mode thickness that has been specifically set on this node via set_render_mode(), or 1.0 if nothing has been set.

float getSa | ( |  | ) |

Gets the alpha scale component of the transform.

float getSb | ( |  | ) |

Gets the blue scale component of the transform.

VBase3 getScale | ( |  | ) |

Retrieves the scale component of the transform.

VBase3 getScale | ( | NodePath const | other | ) |

Returns the relative scale of the bottom node as seen from the other node.

float getSg | ( |  | ) |

Gets the green scale component of the transform.

Shader const getShader | ( |  | ) |

ShaderInput const getShaderInput | ( | InternalName const | id | ) |

ShaderInput const getShaderInput | ( | string | id | ) |

VBase3 getShear | ( |  | ) |

Retrieves the shear component of the transform.

VBase3 getShear | ( | NodePath const | other | ) |

Returns the relative shear of the bottom node as seen from the other node.

float getShxy | ( |  | ) |

float getShxy | ( | NodePath const | other | ) |

Returns the relative shear of the referenced node as seen from the other node.

float getShxz | ( |  | ) |

float getShxz | ( | NodePath const | other | ) |

float getShyz | ( |  | ) |

float getShyz | ( | NodePath const | other | ) |

int getSort | ( | Thread | current_thread | ) |

Returns the sort value of the referenced node within its parent; that is, the sort number passed on the last reparenting operation for this node.

This will control the position of the node within its parent's list of children.

int getSort | ( |  | ) |

Returns the sort value of the referenced node within its parent; that is, the sort number passed on the last reparenting operation for this node.

This will control the position of the node within its parent's list of children.

float getSr | ( |  | ) |

Gets the red scale component of the transform.

NodePath getStashedAncestor | ( | Thread | current_thread | ) |

Returns the NodePath at or above the referenced node that is stashed, or an empty NodePath if no ancestor of the referenced node is stashed (and the node should be visible).

NodePath getStashedAncestor | ( |  | ) |

Returns the NodePath at or above the referenced node that is stashed, or an empty NodePath if no ancestor of the referenced node is stashed (and the node should be visible).

NodePathCollection getStashedChildren | ( | Thread | current_thread | ) |

Returns the set of all child nodes of the referenced node that have been stashed.

These children are not normally visible on the node, and do not appear in the list returned by get_children().

NodePathCollection getStashedChildren | ( |  | ) |

Returns the set of all child nodes of the referenced node that have been stashed.

These children are not normally visible on the node, and do not appear in the list returned by get_children().

RenderState const getState | ( | NodePath const | other,
|  | Thread | current_thread
| ) |  |

Returns the state changes that must be made to transition to the render state of this node from the render state of the other node.

RenderState const getState | ( | NodePath const | other | ) |

Returns the state changes that must be made to transition to the render state of this node from the render state of the other node.

RenderState const getState | ( |  | ) |

Returns the complete state object set on this node.

RenderState const getState | ( | Thread | current_thread | ) |

Returns the complete state object set on this node.

float getSx | ( |  | ) |

float getSx | ( | NodePath const | other | ) |

Returns the relative scale of the referenced node as seen from the other node.

float getSy | ( |  | ) |

float getSy | ( | NodePath const | other | ) |

float getSz | ( |  | ) |

float getSz | ( | NodePath const | other | ) |

string getTag | ( | string | key | ) |

Retrieves the user-defined value that was previously set on this node for the particular key, if any.

If no value has been previously set, returns the empty string. See also get_net_tag().

TexGenMode getTexGen | ( | TextureStage | stage | ) |

Returns the texture coordinate generation mode for the given stage, or M_off if there is no explicit mode set for the given stage.

NodePath getTexGenLight | ( | TextureStage | stage | ) |

Returns the particular Light set for the indicated texgen mode's texture stage, or empty NodePath if no light is set.

This is only meaningful if the texgen mode (returned by get_tex_gen()) is M_light_vector.

VBase3 getTexHpr | ( | TextureStage | stage | ) |

Returns the 3-D HPR set for the UVW's for the given stage on the current node.

This call is appropriate for 3-d texture coordinates.

VBase3 getTexHpr | ( | NodePath const | other,
|  | TextureStage | stage
| ) |  |

Returns the 3-D HPR set for the UVW's for the given stage on the current node.

This call is appropriate for 3-d texture coordinates.

VBase2 getTexOffset | ( | NodePath const | other,
|  | TextureStage | stage
| ) |  |

Returns the offset set for the UV's for the given stage on the current node.

This call is appropriate for ordinary 2-d texture coordinates.

VBase2 getTexOffset | ( | TextureStage | stage | ) |

Returns the offset set for the UV's for the given stage on the current node.

This call is appropriate for ordinary 2-d texture coordinates.

VBase3 getTexPos | ( | NodePath const | other,
|  | TextureStage | stage
| ) |  |

Returns the offset set for the UVW's for the given stage on the current node.

This call is appropriate for 3-d texture coordinates.

VBase3 getTexPos | ( | TextureStage | stage | ) |

Returns the offset set for the UVW's for the given stage on the current node.

This call is appropriate for 3-d texture coordinates.

NodePath getTexProjectorFrom | ( | TextureStage | stage | ) |

Returns the "from" node associated with the TexProjectorEffect on the indicated stage.

The relative transform between the "from" and the "to" nodes is automatically applied to the texture transform each frame.

NodePath getTexProjectorTo | ( | TextureStage | stage | ) |

Returns the "to" node associated with the TexProjectorEffect on the indicated stage.

The relative transform between the "from" and the "to" nodes is automatically applied to the texture transform each frame.

float getTexRotate | ( | NodePath const | other,
|  | TextureStage | stage
| ) |  |

Returns the rotation set for the UV's for the given stage on the current node.

This call is appropriate for ordinary 2-d texture coordinates.

float getTexRotate | ( | TextureStage | stage | ) |

Returns the rotation set for the UV's for the given stage on the current node.

This call is appropriate for ordinary 2-d texture coordinates.

VBase2 getTexScale | ( | NodePath const | other,
|  | TextureStage | stage
| ) |  |

Returns the scale set for the UV's for the given stage on the current node.

This call is appropriate for ordinary 2-d texture coordinates.

VBase2 getTexScale | ( | TextureStage | stage | ) |

Returns the scale set for the UV's for the given stage on the current node.

This call is appropriate for ordinary 2-d texture coordinates.

VBase3 getTexScale3d | ( | NodePath const | other,
|  | TextureStage | stage
| ) |  |

Returns the scale set for the UVW's for the given stage on the current node.

This call is appropriate for 3-d texture coordinates.

VBase3 getTexScale3d | ( | TextureStage | stage | ) |

Returns the scale set for the UVW's for the given stage on the current node.

This call is appropriate for 3-d texture coordinates.

TransformState const getTexTransform | ( | NodePath const | other,
|  | TextureStage | stage
| ) |  |

Returns the texture matrix on the current node for the given stage, relative to the other node.

TransformState const getTexTransform | ( | TextureStage | stage | ) |

Returns the texture matrix on the current node for the given stage, or identity transform if there is no explicit transform set for the given stage.

Texture getTexture | ( |  | ) |

Returns the base-level texture that has been set on this particular node, or NULL if no texture has been set.

This is not necessarily the texture that will be applied to the geometry at or below this level, as another texture at a higher or lower level may override.

See also find_texture().

Texture getTexture | ( | TextureStage | stage | ) |

Returns the texture that has been set on the indicated stage for this particular node, or NULL if no texture has been set for this stage.

NodePath getTop | ( | Thread | current_thread | ) |

Returns a singleton NodePath that represents the top of the path, or empty NodePath if this path is empty.

NodePath getTop | ( |  | ) |

Returns a singleton NodePath that represents the top of the path, or empty NodePath if this path is empty.

PandaNode getTopNode | ( | Thread | current_thread | ) |

Returns the top node of the path, or NULL if the path is empty.

This requires iterating through the path.

PandaNode getTopNode | ( |  | ) |

Returns the top node of the path, or NULL if the path is empty.

This requires iterating through the path.

TransformState const getTransform | ( | NodePath const | other,
|  | Thread | current_thread
| ) |  |

Returns the relative transform to this node from the other node; i.e.

the transformation of this node as seen from the other node.

TransformState const getTransform | ( | NodePath const | other | ) |

Returns the relative transform to this node from the other node; i.e.

the transformation of this node as seen from the other node.

TransformState const getTransform | ( | Thread | current_thread | ) |

Returns the complete transform object set on this node.

TransformState const getTransform | ( |  | ) |

Returns the complete transform object set on this node.

Mode getTransparency | ( |  | ) |

Returns the transparent rendering that has been specifically set on this node via set_transparency(), or M_none if nontransparent rendering has been specifically set, or if nothing has been specifically set.

See also has_transparency(). This does not necessarily imply that the geometry will or will not be rendered transparent, as there may be other nodes that override.

bool getTwoSided | ( |  | ) |

Returns true if two-sided rendering has been specifically set on this node via set_two_sided(), or false if one-sided rendering has been specifically set, or if nothing has been specifically set.

See also has_two_sided(). This does not necessarily imply that the geometry will or will not be rendered two-sided, as there may be other nodes that override.

float getX | ( | NodePath const | other | ) |

float getX | ( |  | ) |

float getY | ( |  | ) |

float getY | ( | NodePath const | other | ) |

float getZ | ( |  | ) |

float getZ | ( | NodePath const | other | ) |

bool hasAntialias | ( |  | ) |

Returns true if an antialias setting has been explicitly mode on this particular node via set_antialias().

If this returns true, then get_antialias() may be called to determine what the setting was.

bool hasAttrib | ( | TypeHandle | type | ) |

Returns true if there is a render attribute of the indicated type defined on this node, or false if there is not.

bool hasAudioVolume | ( |  | ) |

Returns true if an audio volume has been applied to the referenced node, false otherwise.

It is still possible that volume at this node might have been scaled by an ancestor node.

bool hasBillboard | ( |  | ) |

Returns true if there is any billboard effect on the node.

bool hasBin | ( |  | ) |

Returns true if the node has been assigned to the a particular rendering bin via set_bin(), false otherwise.

bool hasClipPlane | ( | NodePath const | clip_plane | ) |

Returns true if the indicated clipping plane has been specifically applied to this particular node.

This means that someone called set_clip_plane() on this node with the indicated clip_plane.

bool hasClipPlaneOff | ( | NodePath const | clip_plane | ) |

Returns true if the indicated clipping plane has been specifically disabled on this particular node.

This means that someone called set_clip_plane_off() on this node with the indicated clip_plane.

bool hasClipPlaneOff | ( |  | ) |

Returns true if all clipping planes have been specifically disabled on this particular node.

This means that someone called set_clip_plane_off() on this node with no parameters.

bool hasColor | ( |  | ) |

Returns true if a color has been applied to the given node, false otherwise.

bool hasColorScale | ( |  | ) |

Returns true if a color scale has been applied to the referenced node, false otherwise.

It is still possible that color at this node might have been scaled by an ancestor node.

bool hasCompass | ( |  | ) |

Returns true if there is any compass effect on the node.

bool hasDepthOffset | ( |  | ) |

Returns true if a depth-offset adjustment has been explicitly set on this particular node via set_depth_offset().

If this returns true, then get_depth_offset() may be called to determine which has been set.

bool hasDepthTest | ( |  | ) |

Returns true if a depth-test adjustment has been explicitly set on this particular node via set_depth_test().

If this returns true, then get_depth_test() may be called to determine which has been set.

bool hasDepthWrite | ( |  | ) |

Returns true if a depth-write adjustment has been explicitly set on this particular node via set_depth_write().

If this returns true, then get_depth_write() may be called to determine which has been set.

bool hasEffect | ( | TypeHandle | type | ) |

Returns true if there is a render effect of the indicated type defined on this node, or false if there is not.

bool hasFog | ( |  | ) |

Returns true if a fog has been applied to this particular node via set_fog(), false otherwise.

This is not the same thing as asking whether the geometry at this node will be rendered with fog, as there may be a fog in effect from a higher or lower level.

bool hasFogOff | ( |  | ) |

Returns true if a fog has been specifically disabled on this particular node via set_fog_off(), false otherwise.

This is not the same thing as asking whether the geometry at this node will be rendered unfogged, as there may be a fog in effect from a higher or lower level.

bool hasLight | ( | NodePath const | light | ) |

Returns true if the indicated Light or PolylightNode has been specifically enabled on this particular node.

This means that someone called set_light() on this node with the indicated light.

bool hasLightOff | ( |  | ) |

Returns true if all Lights have been specifically disabled on this particular node.

This means that someone called set_light_off() on this node with no parameters.

bool hasLightOff | ( | NodePath const | light | ) |

Returns true if the indicated Light has been specifically disabled on this particular node.

This means that someone called set_light_off() on this node with the indicated light.

This interface does not support PolylightNodes, which cannot be turned off at a lower level.

bool hasMat | ( |  | ) |

Returns true if a non-identity transform matrix has been applied to the referenced node, false otherwise.

bool hasMaterial | ( |  | ) |

Returns true if a material has been applied to this particular node via set_material(), false otherwise.

bool hasNetPythonTag | ( | string | key | ) |

Returns true if the indicated Python object has been defined on this node or on any ancestor node, or false otherwise.

See also has_python_tag().

bool hasNetTag | ( | string | key | ) |

Returns true if the indicated tag value has been defined on this node or on any ancestor node, or false otherwise.

See also has_tag().

bool hasOccluder | ( | NodePath const | occluder | ) |

Returns true if the indicated occluder has been specifically applied to this particular node.

This means that someone called set_occluder() on this node with the indicated occluder.

bool hasParent | ( | Thread | current_thread | ) |

Returns true if the referenced node has a parent; i.e.

the NodePath chain contains at least two nodes.

bool hasParent | ( |  | ) |

Returns true if the referenced node has a parent; i.e.

the NodePath chain contains at least two nodes.

bool hasPythonTag | ( | string | key | ) |

Returns true if a Python object has been defined on this node for the particular key (even if that value is the empty string), or false if no value has been set.

See also has_net_python_tag().

bool hasRenderMode | ( |  | ) |

Returns true if a render mode has been explicitly set on this particular node via set_render_mode() (or set_render_mode_wireframe() or set_render_mode_filled()), false otherwise.

bool hasScissor | ( |  | ) |

Returns true if a scissor region was defined at this node by a previous call to set_scissor().

This does not check for scissor regions inherited from a parent class. It also does not check for the presence of a low-level ScissorAttrib, which is different from the ScissorEffect added by set_scissor.

bool hasTag | ( | string | key | ) |

Returns true if a value has been defined on this node for the particular key (even if that value is the empty string), or false if no value has been set.

See also has_net_tag().

bool hasTexcoord | ( | string | texcoord_name | ) |

Returns true if there are at least some vertices at this node and below that use the named texture coordinate set, false otherwise.

Pass the empty string for the default texture coordinate set.

bool hasTexGen | ( | TextureStage | stage | ) |

Returns true if there is a mode for automatic texture coordinate generation on the current node for the given stage.

bool hasTexProjector | ( | TextureStage | stage | ) |

Returns true if this node has a TexProjectorEffect for the indicated stage, false otherwise.

bool hasTexTransform | ( | TextureStage | stage | ) |

Returns true if there is an explicit texture matrix on the current node for the given stage.

bool hasTexture | ( |  | ) |

Returns true if a texture has been applied to this particular node via set_texture(), false otherwise.

This is not the same thing as asking whether the geometry at this node will be rendered with texturing, as there may be a texture in effect from a higher or lower level.

bool hasTexture | ( | TextureStage | stage | ) |

Returns true if texturing has been specifically enabled on this particular node for the indicated stage.

This means that someone called set_texture() on this node with the indicated stage name, or the stage_name is the default stage_name, and someone called set_texture() on this node.

bool hasTextureOff | ( |  | ) |

Returns true if texturing has been specifically disabled on this particular node via set_texture_off(), false otherwise.

This is not the same thing as asking whether the geometry at this node will be rendered untextured, as there may be a texture in effect from a higher or lower level.

bool hasTextureOff | ( | TextureStage | stage | ) |

Returns true if texturing has been specifically disabled on this particular node for the indicated stage.

This means that someone called set_texture_off() on this node with the indicated stage name, or that someone called set_texture_off() on this node to remove all stages.

bool hasTransparency | ( |  | ) |

Returns true if a transparent-rendering adjustment has been explicitly set on this particular node via set_transparency().

If this returns true, then get_transparency() may be called to determine whether transparency has been explicitly enabled or explicitly disabled for this node.

bool hasTwoSided | ( |  | ) |

Returns true if a two-sided adjustment has been explicitly set on this particular node via set_two_sided().

If this returns true, then get_two_sided() may be called to determine which has been set.

bool hasVertexColumn | ( | InternalName const | name | ) |

Returns true if there are at least some vertices at this node and below that contain a reference to the indicated vertex data column name, false otherwise.

This is particularly useful for testing whether a particular model has a given texture coordinate set (but see has_texcoord()).

headsUp | ( | Point3 const | point,
|  | Vec3 const | up
| ) |  |

Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.

headsUp | ( | Point3 const | point | ) |

Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.

headsUp | ( | NodePath const | other,
|  | Point3 const | point,
|  | Vec3 const | up
| ) |  |

Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.

headsUp | ( | NodePath const | other,
|  | Point3 const | point
| ) |  |

Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.

headsUp | ( | NodePath const | other | ) |

Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.

headsUp | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |

Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.

headsUp | ( | NodePath const | other,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

Behaves like look_at(), but with a strong preference to keeping the up vector oriented in the indicated "up" direction.

hide | ( |  | ) |

Makes the referenced node (and the entire subgraph below this node) invisible to all cameras.

It remains part of the scene graph, its bounding volume still contributes to its parent's bounding volume, and it will still be involved in collision tests.

hide | ( | BitMaskunsigned | int,
|  | 32 | camera_mask
| ) |  |

Makes the referenced node invisible just to the cameras whose camera_mask shares the indicated bits.

This will also hide any nodes below this node in the scene graph, including those nodes for which show() has been called, but it will not hide descendent nodes for which show_through() has been called.

hideBounds | ( |  | ) |

Stops the rendering of the bounding volume begun with show_bounds().

NodePath instanceTo | ( | NodePath const | other,
|  | int | sort,
|  | Thread | current_thread
| ) |  |

Adds the referenced node of the NodePath as a child of the referenced node of the indicated other NodePath.

Any other parent-child relations of the node are unchanged; in particular, the node is not removed from its existing parent, if any.

If the node already had an existing parent, this method will create a new instance of the node within the scene graph.

This does not change the NodePath itself, but does return a new NodePath that reflects the new instance node.

If the destination NodePath is empty, this creates a new instance which is not yet parented to any node. A new instance of this sort cannot easily be differentiated from other similar instances, but it is nevertheless a different instance and it will return a different get_id() value.

If the referenced node is already a child of the indicated NodePath, returns that already-existing instance, unstashing it first if necessary.

NodePath instanceTo | ( | NodePath const | other,
|  | int | sort
| ) |  |

Adds the referenced node of the NodePath as a child of the referenced node of the indicated other NodePath.

Any other parent-child relations of the node are unchanged; in particular, the node is not removed from its existing parent, if any.

If the node already had an existing parent, this method will create a new instance of the node within the scene graph.

This does not change the NodePath itself, but does return a new NodePath that reflects the new instance node.

If the destination NodePath is empty, this creates a new instance which is not yet parented to any node. A new instance of this sort cannot easily be differentiated from other similar instances, but it is nevertheless a different instance and it will return a different get_id() value.

If the referenced node is already a child of the indicated NodePath, returns that already-existing instance, unstashing it first if necessary.

NodePath instanceTo | ( | NodePath const | other | ) |

Adds the referenced node of the NodePath as a child of the referenced node of the indicated other NodePath.

Any other parent-child relations of the node are unchanged; in particular, the node is not removed from its existing parent, if any.

If the node already had an existing parent, this method will create a new instance of the node within the scene graph.

This does not change the NodePath itself, but does return a new NodePath that reflects the new instance node.

If the destination NodePath is empty, this creates a new instance which is not yet parented to any node. A new instance of this sort cannot easily be differentiated from other similar instances, but it is nevertheless a different instance and it will return a different get_id() value.

If the referenced node is already a child of the indicated NodePath, returns that already-existing instance, unstashing it first if necessary.

NodePath instanceUnderNode | ( | NodePath const | other,
|  | string | name,
|  | int | sort,
|  | Thread | current_thread
| ) |  |

Behaves like instance_to(), but implicitly creates a new node to instance the geometry under, and returns a NodePath to that new node.

This allows the programmer to set a unique state and/or transform on this instance.

NodePath instanceUnderNode | ( | NodePath const | other,
|  | string | name,
|  | int | sort
| ) |  |

Behaves like instance_to(), but implicitly creates a new node to instance the geometry under, and returns a NodePath to that new node.

This allows the programmer to set a unique state and/or transform on this instance.

NodePath instanceUnderNode | ( | NodePath const | other,
|  | string | name
| ) |  |

Behaves like instance_to(), but implicitly creates a new node to instance the geometry under, and returns a NodePath to that new node.

This allows the programmer to set a unique state and/or transform on this instance.

bool isAncestorOf | ( | NodePath const | other,
|  | Thread | current_thread
| ) |  |

Returns true if the node represented by this NodePath is a parent or other ancestor of the other NodePath, or false if it is not.

bool isAncestorOf | ( | NodePath const | other | ) |

Returns true if the node represented by this NodePath is a parent or other ancestor of the other NodePath, or false if it is not.

bool isEmpty | ( |  | ) |

Returns true if the NodePath contains no nodes.

bool isHidden | ( | BitMaskunsigned | int,
|  | 32 | camera_mask
| ) |  |

Returns true if the referenced node is hidden from the indicated camera(s) either directly, or because some ancestor is hidden.

bool isHidden | ( |  | ) |

Returns true if the referenced node is hidden from the indicated camera(s) either directly, or because some ancestor is hidden.

bool isSameGraph | ( | NodePath const | other | ) |

Returns true if the node represented by this NodePath is parented within the same graph as that of the other NodePath.

This is essentially the same thing as asking whether get_top() of both NodePaths is the same (e.g., both "render").

bool isSameGraph | ( | NodePath const | other,
|  | Thread | current_thread
| ) |  |

Returns true if the node represented by this NodePath is parented within the same graph as that of the other NodePath.

This is essentially the same thing as asking whether get_top() of both NodePaths is the same (e.g., both "render").

bool isSingleton | ( | Thread | current_thread | ) |

Returns true if the NodePath contains exactly one node.

bool isSingleton | ( |  | ) |

Returns true if the NodePath contains exactly one node.

bool isStashed | ( |  | ) |

Returns true if the referenced node is stashed either directly, or because some ancestor is stashed.

listTags | ( |  | ) |

Lists the tags to the nout stream, one per line.

See PandaNode.list_tags() for a variant that allows you to specify the output stream.

lookAt | ( | NodePath const | other,
|  | Point3 const | point,
|  | Vec3 const | up
| ) |  |

Sets the transform on this NodePath so that it rotates to face the indicated point in space, which is relative to the other NodePath.

lookAt | ( | NodePath const | other,
|  | Point3 const | point
| ) |  |

Sets the transform on this NodePath so that it rotates to face the indicated point in space, which is relative to the other NodePath.

lookAt | ( | NodePath const | other | ) |

Sets the transform on this NodePath so that it rotates to face the indicated point in space, which is relative to the other NodePath.

lookAt | ( | NodePath const | other,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

Sets the hpr on this NodePath so that it rotates to face the indicated point in space, which is relative to the other NodePath.

lookAt | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |

Sets the transform on this NodePath so that it rotates to face the indicated point in space.

This will overwrite any previously existing scale on the node, although it will preserve any translation.

lookAt | ( | Point3 const | point,
|  | Vec3 const | up
| ) |  |

Sets the hpr on this NodePath so that it rotates to face the indicated point in space.

lookAt | ( | Point3 const | point | ) |

Sets the hpr on this NodePath so that it rotates to face the indicated point in space.

ls | ( |  | ) |

Lists the hierarchy at and below the referenced node.

ls | ( | ostream | out | ) |

Lists the hierarchy at and below the referenced node.

ls | ( | ostream | out,
|  | int | indent_level
| ) |  |

Lists the hierarchy at and below the referenced node.

PandaNode node | ( |  | ) |

Returns the referenced node of the path.

static NodePath notFound | ( |  | ) | `[static]`

Creates a NodePath with the ET_not_found error type set.

bool operator!= | ( | NodePath const | other | ) |

Returns true if the two paths are not equivalent.

bool operator< | ( | NodePath const | other | ) |

Returns true if this NodePath sorts before the other one, false otherwise.

The sorting order of two nonequivalent NodePaths is consistent but undefined, and is useful only for storing NodePaths in a sorted container like an STL set.

NodePath operator= | ( | NodePath const | copy | ) |

bool operator== | ( | NodePath const | other | ) |

Returns true if the two paths are equivalent; that is, if they contain the same list of nodes in the same order.

output | ( | ostream | out | ) |

Writes a sensible description of the NodePath to the indicated output stream.

premungeScene | ( | GraphicsStateGuardianBase | gsg | ) |

Walks through the scene graph beginning at the bottom node, and internally adjusts any GeomVertexFormats for optimal rendering on the indicated GSG.

If this step is not done prior to rendering, the formats will be optimized at render time instead, for a small cost.

It is not normally necessary to do this on a model loaded directly from disk, since the loader will do this by default.

premungeScene | ( |  | ) |

Walks through the scene graph beginning at the bottom node, and internally adjusts any GeomVertexFormats for optimal rendering on the indicated GSG.

If this step is not done prior to rendering, the formats will be optimized at render time instead, for a small cost.

It is not normally necessary to do this on a model loaded directly from disk, since the loader will do this by default.

prepareScene | ( | GraphicsStateGuardianBase | gsg | ) |

Walks through the scene graph beginning at the bottom node, and does whatever initialization is required to render the scene properly with the indicated GSG.

It is not strictly necessary to call this, since the GSG will initialize itself when the scene is rendered, but this may take some of the overhead away from that process.

In particular, this will ensure that textures and vertex buffers within the scene are loaded into graphics memory.

projectTexture | ( | TextureStage | stage,
|  | Texture | tex,
|  | NodePath const | projector
| ) |  |

A convenience function to enable projective texturing at this node level and below, using the indicated NodePath (which should contain a LensNode) as the projector.

PyObject reduce | ( | PyObject | self | ) |

This special Python method is implement to provide support for the pickle module.

This hooks into the native pickle and cPickle modules, but it cannot properly handle self-referential BAM objects.

PyObject reducePersist | ( | PyObject | self,
|  | PyObject | pickler
| ) |  |

This special Python method is implement to provide support for the pickle module.

This is similar to __reduce__, but it provides additional support for the missing persistent-state object needed to properly support self-referential BAM objects written to the pickle stream. This hooks into the pickle and cPickle modules implemented in direct/src/stdpy.

static NodePath removed | ( |  | ) | `[static]`

Creates a NodePath with the ET_removed error type set.

removeNode | ( | Thread | current_thread | ) |

Disconnects the referenced node from the scene graph.

This will also delete the node if there are no other pointers to it.

Normally, this should be called only when you are really done with the node. If you want to remove a node from the scene graph but keep it around for later, you should probably use detach_node() instead.

In practice, the only difference between remove_node() and detach_node() is that remove_node() also resets the NodePath to empty, which will cause the node to be deleted immediately if there are no other references. On the other hand, detach_node() leaves the NodePath referencing the node, which will keep at least one reference to the node for as long as the NodePath exists.

removeNode | ( |  | ) |

Disconnects the referenced node from the scene graph.

This will also delete the node if there are no other pointers to it.

Normally, this should be called only when you are really done with the node. If you want to remove a node from the scene graph but keep it around for later, you should probably use detach_node() instead.

In practice, the only difference between remove_node() and detach_node() is that remove_node() also resets the NodePath to empty, which will cause the node to be deleted immediately if there are no other references. On the other hand, detach_node() leaves the NodePath referencing the node, which will keep at least one reference to the node for as long as the NodePath exists.

reparentTo | ( | NodePath const | other,
|  | int | sort,
|  | Thread | current_thread
| ) |  |

Removes the referenced node of the NodePath from its current parent and attaches it to the referenced node of the indicated NodePath.

If the destination NodePath is empty, this is the same thing as detach_node().

If the referenced node is already a child of the indicated NodePath (via some other instance), this operation fails and leaves the NodePath detached.

reparentTo | ( | NodePath const | other,
|  | int | sort
| ) |  |

Removes the referenced node of the NodePath from its current parent and attaches it to the referenced node of the indicated NodePath.

If the destination NodePath is empty, this is the same thing as detach_node().

If the referenced node is already a child of the indicated NodePath (via some other instance), this operation fails and leaves the NodePath detached.

reparentTo | ( | NodePath const | other | ) |

Removes the referenced node of the NodePath from its current parent and attaches it to the referenced node of the indicated NodePath.

If the destination NodePath is empty, this is the same thing as detach_node().

If the referenced node is already a child of the indicated NodePath (via some other instance), this operation fails and leaves the NodePath detached.

reverseLs | ( |  | ) |

Lists the hierarchy at and above the referenced node.

int reverseLs | ( | ostream | out,
|  | int | indent_level
| ) |  |

Lists the hierarchy at and above the referenced node.

int reverseLs | ( | ostream | out | ) |

Lists the hierarchy at and above the referenced node.

setAllColorScale | ( | float | scale,
|  | int | priority
| ) |  |

Scales all the color components of the object by the same amount, darkening the object, without (much) affecting alpha.

Note that any priority specified will also apply to the alpha scale.

setAllColorScale | ( | float | scale | ) |

Scales all the color components of the object by the same amount, darkening the object, without (much) affecting alpha.

Note that any priority specified will also apply to the alpha scale.

setAlphaScale | ( | float | scale,
|  | int | priority
| ) |  |

Sets the alpha scale component of the transform without (much) affecting the color scale.

Note that any priority specified will also apply to the color scale.

setAlphaScale | ( | float | scale | ) |

Sets the alpha scale component of the transform without (much) affecting the color scale.

Note that any priority specified will also apply to the color scale.

setAntialias | ( | unsigned short int | mode,
|  | int | priority
| ) |  |

Specifies the antialiasing type that should be applied at this node and below.

See AntialiasAttrib.

setAntialias | ( | unsigned short int | mode | ) |

Specifies the antialiasing type that should be applied at this node and below.

See AntialiasAttrib.

setAttrib | ( | RenderAttrib const | attrib,
|  | int | priority
| ) |  |

Adds the indicated render attribute to the scene graph on this node.

This attribute will now apply to this node and everything below. If there was already an attribute of the same type, it is replaced.

setAttrib | ( | RenderAttrib const | attrib | ) |

Adds the indicated render attribute to the scene graph on this node.

This attribute will now apply to this node and everything below. If there was already an attribute of the same type, it is replaced.

setAudioVolume | ( | float | volume,
|  | int | priority
| ) |  |

Sets the audio volume component of the transform.

setAudioVolume | ( | float | volume | ) |

Sets the audio volume component of the transform.

setAudioVolumeOff | ( |  | ) |

Disables any audio volume attribute inherited from above.

This is not the same thing as clear_audio_volume(), which undoes any previous set_audio_volume() operation on this node; rather, this actively disables any set_audio_volume() that might be inherited from a parent node.

It is legal to specify a new volume on the same node with a subsequent call to set_audio_volume(); this new scale will apply to lower nodes.

setAudioVolumeOff | ( | int | priority | ) |

Disables any audio volume attribute inherited from above.

This is not the same thing as clear_audio_volume(), which undoes any previous set_audio_volume() operation on this node; rather, this actively disables any set_audio_volume() that might be inherited from a parent node.

It is legal to specify a new volume on the same node with a subsequent call to set_audio_volume(); this new scale will apply to lower nodes.

setBillboardAxis | ( |  | ) |

Puts a billboard transition on the node such that it will rotate in two dimensions around the up axis.

setBillboardAxis | ( | NodePath const | camera,
|  | float | offset
| ) |  |

Puts a billboard transition on the node such that it will rotate in two dimensions around the up axis, towards a specified "camera" instead of to the viewing camera.

setBillboardAxis | ( | float | offset | ) |

Puts a billboard transition on the node such that it will rotate in two dimensions around the up axis.

setBillboardPointEye | ( | NodePath const | camera,
|  | float | offset
| ) |  |

Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the top of the camera, towards a specified "camera" instead of to the viewing camera.

setBillboardPointEye | ( |  | ) |

Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the top of the camera.

setBillboardPointEye | ( | float | offset | ) |

Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the top of the camera.

setBillboardPointWorld | ( | float | offset | ) |

Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the sky.

setBillboardPointWorld | ( |  | ) |

Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the sky.

setBillboardPointWorld | ( | NodePath const | camera,
|  | float | offset
| ) |  |

Puts a billboard transition on the node such that it will rotate in three dimensions about the origin, keeping its up vector oriented to the sky, towards a specified "camera" instead of to the viewing camera.

setBin | ( | string | bin_name,
|  | int | draw_order,
|  | int | priority
| ) |  |

Assigns the geometry at this level and below to the named rendering bin.

It is the user's responsibility to ensure that such a bin already exists, either via the cull-bin Configrc variable, or by explicitly creating a GeomBin of the appropriate type at runtime.

There are two default bins created when Panda is started: "default" and "fixed". Normally, all geometry is assigned to "default" unless specified otherwise. This bin renders opaque geometry in state-sorted order, followed by transparent geometry sorted back-to-front. If any geometry is assigned to "fixed", this will be rendered following all the geometry in "default", in the order specified by draw_order for each piece of geometry so assigned.

The draw_order parameter is meaningful only for GeomBinFixed type bins, e.g. "fixed". Other kinds of bins ignore it.

setBin | ( | string | bin_name,
|  | int | draw_order
| ) |  |

Assigns the geometry at this level and below to the named rendering bin.

It is the user's responsibility to ensure that such a bin already exists, either via the cull-bin Configrc variable, or by explicitly creating a GeomBin of the appropriate type at runtime.

There are two default bins created when Panda is started: "default" and "fixed". Normally, all geometry is assigned to "default" unless specified otherwise. This bin renders opaque geometry in state-sorted order, followed by transparent geometry sorted back-to-front. If any geometry is assigned to "fixed", this will be rendered following all the geometry in "default", in the order specified by draw_order for each piece of geometry so assigned.

The draw_order parameter is meaningful only for GeomBinFixed type bins, e.g. "fixed". Other kinds of bins ignore it.

setClipPlane | ( | NodePath const | clip_plane | ) |

Adds the indicated clipping plane to the list of planes that apply to geometry at this node and below.

The clipping plane itself, a PlaneNode, should be parented into the scene graph elsewhere, to represent the plane's position in space; but until set_clip_plane() is called it will clip no geometry.

setClipPlane | ( | NodePath const | clip_plane,
|  | int | priority
| ) |  |

Adds the indicated clipping plane to the list of planes that apply to geometry at this node and below.

The clipping plane itself, a PlaneNode, should be parented into the scene graph elsewhere, to represent the plane's position in space; but until set_clip_plane() is called it will clip no geometry.

setClipPlaneOff | ( | NodePath const | clip_plane | ) |

Sets the geometry at this level and below to render without being clipped by the indicated PlaneNode.

This is different from not specifying the PlaneNode; rather, this specifically contradicts set_clip_plane() at a higher node level (or, with a priority, overrides a set_clip_plane() at a lower level).

setClipPlaneOff | ( | NodePath const | clip_plane,
|  | int | priority
| ) |  |

Sets the geometry at this level and below to render without being clipped by the indicated PlaneNode.

This is different from not specifying the PlaneNode; rather, this specifically contradicts set_clip_plane() at a higher node level (or, with a priority, overrides a set_clip_plane() at a lower level).

setClipPlaneOff | ( | int | priority | ) |

Sets the geometry at this level and below to render using no clip_planes at all.

This is different from not specifying a clip_plane; rather, this specifically contradicts set_clip_plane() at a higher node level (or, with a priority, overrides a set_clip_plane() at a lower level).

If no clip_planes are in effect on a particular piece of geometry, that geometry is rendered without being clipped (other than by the viewing frustum).

setClipPlaneOff | ( |  | ) |

Sets the geometry at this level and below to render using no clip_planes at all.

This is different from not specifying a clip_plane; rather, this specifically contradicts set_clip_plane() at a higher node level (or, with a priority, overrides a set_clip_plane() at a lower level).

If no clip_planes are in effect on a particular piece of geometry, that geometry is rendered without being clipped (other than by the viewing frustum).

setCollideMask | ( | BitMaskunsigned | int,
|  | 32 | new_mask,
|  | BitMaskunsigned | int,
|  | 32 | bits_to_change
| ) |  |

Recursively applies the indicated CollideMask to the into_collide_masks for all nodes at this level and below.

If node_type is not TypeHandle.none(), then only nodes matching (or inheriting from) the indicated PandaNode subclass are modified.

The default is to change all bits, but if bits_to_change is not all bits on, then only the bits that are set in bits_to_change are modified, allowing this call to change only a subset of the bits in the subgraph.

setCollideMask | ( | BitMaskunsigned | int,
|  | 32 | new_mask
| ) |  |

Recursively applies the indicated CollideMask to the into_collide_masks for all nodes at this level and below.

If node_type is not TypeHandle.none(), then only nodes matching (or inheriting from) the indicated PandaNode subclass are modified.

The default is to change all bits, but if bits_to_change is not all bits on, then only the bits that are set in bits_to_change are modified, allowing this call to change only a subset of the bits in the subgraph.

setCollideMask | ( | BitMaskunsigned | int,
|  | 32 | new_mask,
|  | BitMaskunsigned | int,
|  | 32 | bits_to_change,
|  | TypeHandle | node_type
| ) |  |

Recursively applies the indicated CollideMask to the into_collide_masks for all nodes at this level and below.

If node_type is not TypeHandle.none(), then only nodes matching (or inheriting from) the indicated PandaNode subclass are modified.

The default is to change all bits, but if bits_to_change is not all bits on, then only the bits that are set in bits_to_change are modified, allowing this call to change only a subset of the bits in the subgraph.

setColor | ( | VBase4 const | color | ) |

Applies a scene-graph color to the referenced node.

This color will apply to all geometry at this level and below (that does not specify a new color or a set_color_off()).

setColor | ( | float | r,
|  | float | g,
|  | float | b,
|  | float | a,
|  | int | priority
| ) |  |

Applies a scene-graph color to the referenced node.

This color will apply to all geometry at this level and below (that does not specify a new color or a set_color_off()).

setColor | ( | float | r,
|  | float | g,
|  | float | b,
|  | float | a
| ) |  |

Applies a scene-graph color to the referenced node.

This color will apply to all geometry at this level and below (that does not specify a new color or a set_color_off()).

setColor | ( | float | r,
|  | float | g,
|  | float | b
| ) |  |

Applies a scene-graph color to the referenced node.

This color will apply to all geometry at this level and below (that does not specify a new color or a set_color_off()).

setColor | ( | VBase4 const | color,
|  | int | priority
| ) |  |

Applies a scene-graph color to the referenced node.

This color will apply to all geometry at this level and below (that does not specify a new color or a set_color_off()).

setColorOff | ( | int | priority | ) |

Sets the geometry at this level and below to render using the geometry color.

This is normally the default, but it may be useful to use this to contradict set_color() at a higher node level (or, with a priority, to override a set_color() at a lower level).

setColorOff | ( |  | ) |

Sets the geometry at this level and below to render using the geometry color.

This is normally the default, but it may be useful to use this to contradict set_color() at a higher node level (or, with a priority, to override a set_color() at a lower level).

setColorScale | ( | VBase4 const | scale,
|  | int | priority
| ) |  |

Sets the color scale component of the transform, leaving translation and rotation untouched.

setColorScale | ( | VBase4 const | scale | ) |

Sets the color scale component of the transform, leaving translation and rotation untouched.

setColorScale | ( | float | sx,
|  | float | sy,
|  | float | sz,
|  | float | sa,
|  | int | priority
| ) |  |

Sets the color scale component of the transform.

setColorScale | ( | float | sx,
|  | float | sy,
|  | float | sz,
|  | float | sa
| ) |  |

Sets the color scale component of the transform.

setColorScaleOff | ( | int | priority | ) |

Disables any color scale attribute inherited from above.

This is not the same thing as clear_color_scale(), which undoes any previous set_color_scale() operation on this node; rather, this actively disables any set_color_scale() that might be inherited from a parent node. This also disables set_alpha_scale() at the same time.

It is legal to specify a new color scale on the same node with a subsequent call to set_color_scale() or set_alpha_scale(); this new scale will apply to lower geometry.

setColorScaleOff | ( |  | ) |

Disables any color scale attribute inherited from above.

This is not the same thing as clear_color_scale(), which undoes any previous set_color_scale() operation on this node; rather, this actively disables any set_color_scale() that might be inherited from a parent node. This also disables set_alpha_scale() at the same time.

It is legal to specify a new color scale on the same node with a subsequent call to set_color_scale() or set_alpha_scale(); this new scale will apply to lower geometry.

setCompass | ( | NodePath const | reference | ) |

Puts a compass effect on the node, so that it will retain a fixed rotation relative to the reference node (or render if the reference node is empty) regardless of the transforms above it.

setCompass | ( |  | ) |

Puts a compass effect on the node, so that it will retain a fixed rotation relative to the reference node (or render if the reference node is empty) regardless of the transforms above it.

setDepthOffset | ( | int | bias | ) |

This instructs the graphics driver to apply an offset or bias to the generated depth values for rendered polygons, before they are written to the depth buffer.

This can be used to shift polygons forward slightly, to resolve depth conflicts, or self-shadowing artifacts on thin objects. The bias is always an integer number, and each integer increment represents the smallest possible increment in Z that is sufficient to completely resolve two coplanar polygons. Positive numbers are closer towards the camera.

setDepthOffset | ( | int | bias,
|  | int | priority
| ) |  |

This instructs the graphics driver to apply an offset or bias to the generated depth values for rendered polygons, before they are written to the depth buffer.

This can be used to shift polygons forward slightly, to resolve depth conflicts, or self-shadowing artifacts on thin objects. The bias is always an integer number, and each integer increment represents the smallest possible increment in Z that is sufficient to completely resolve two coplanar polygons. Positive numbers are closer towards the camera.

setDepthTest | ( | bool | depth_test,
|  | int | priority
| ) |  |

Specifically sets or disables the testing of the depth buffer on this particular node.

This is normally on in the 3-d scene graph and off in the 2-d scene graph; it should be on for rendering most 3-d objects properly.

setDepthTest | ( | bool | depth_test | ) |

Specifically sets or disables the testing of the depth buffer on this particular node.

This is normally on in the 3-d scene graph and off in the 2-d scene graph; it should be on for rendering most 3-d objects properly.

setDepthWrite | ( | bool | depth_write | ) |

Specifically sets or disables the writing to the depth buffer on this particular node.

This is normally on in the 3-d scene graph and off in the 2-d scene graph; it should be on for rendering most 3-d objects properly.

setDepthWrite | ( | bool | depth_write,
|  | int | priority
| ) |  |

Specifically sets or disables the writing to the depth buffer on this particular node.

This is normally on in the 3-d scene graph and off in the 2-d scene graph; it should be on for rendering most 3-d objects properly.

setEffect | ( | RenderEffect const | effect | ) |

Adds the indicated render effect to the scene graph on this node.

If there was already an effect of the same type, it is replaced.

setEffects | ( | RenderEffects const | effects | ) |

Sets the complete RenderEffects that will be applied this node.

This completely replaces whatever has been set on this node via repeated calls to set_attrib().

setFluidPos | ( | VBase3 const | pos | ) |

Sets the translation component, without changing the "previous" position, so that the collision system will see the node as moving fluidly from its previous position to its new position.

See Also: NodePath.set_pos

setFluidPos | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |

Sets the translation component, without changing the "previous" position, so that the collision system will see the node as moving fluidly from its previous position to its new position.

setFluidPos | ( | NodePath const | other,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

Sets the translation component, without changing the "previous" position, so that the collision system will see the node as moving fluidly from its previous position to its new position.

setFluidPos | ( | NodePath const | other,
|  | VBase3 const | pos
| ) |  |

Sets the translation component of the transform, relative to the other node.

setFluidX | ( | NodePath const | other,
|  | float | x
| ) |  |

setFluidX | ( | float | x | ) |

setFluidY | ( | float | y | ) |

setFluidY | ( | NodePath const | other,
|  | float | y
| ) |  |

setFluidZ | ( | NodePath const | other,
|  | float | z
| ) |  |

setFluidZ | ( | float | z | ) |

setFog | ( | Fog | fog | ) |

Sets the geometry at this level and below to render using the indicated fog.

setFog | ( | Fog | fog,
|  | int | priority
| ) |  |

Sets the geometry at this level and below to render using the indicated fog.

setFogOff | ( | int | priority | ) |

Sets the geometry at this level and below to render using no fog.

This is normally the default, but it may be useful to use this to contradict set_fog() at a higher node level (or, with a priority, to override a set_fog() at a lower level).

setFogOff | ( |  | ) |

Sets the geometry at this level and below to render using no fog.

This is normally the default, but it may be useful to use this to contradict set_fog() at a higher node level (or, with a priority, to override a set_fog() at a lower level).

setH | ( | float | h | ) |

setH | ( | NodePath const | other,
|  | float | h
| ) |  |

setHpr | ( | float | h,
|  | float | p,
|  | float | r
| ) |  |

Sets the rotation component of the transform, leaving translation and scale untouched.

setHpr | ( | NodePath const | other,
|  | VBase3 const | hpr
| ) |  |

Sets the rotation component of the transform, relative to the other node.

setHpr | ( | NodePath const | other,
|  | float | h,
|  | float | p,
|  | float | r
| ) |  |

Sets the rotation component of the transform, relative to the other node.

setHpr | ( | VBase3 const | hpr | ) |

Sets the rotation component of the transform, leaving translation and scale untouched.

setHprScale | ( | VBase3 const | hpr,
|  | VBase3 const | scale
| ) |  |

Sets the rotation and scale components of the transform, leaving translation untouched.

setHprScale | ( | NodePath const | other,
|  | VBase3 const | hpr,
|  | VBase3 const | scale
| ) |  |

Sets the rotation and scale components of the transform, leaving translation untouched.

This, or set_pos_hpr_scale, is the preferred way to update a transform when both hpr and scale are to be changed.

setHprScale | ( | NodePath const | other,
|  | float | h,
|  | float | p,
|  | float | r,
|  | float | sx,
|  | float | sy,
|  | float | sz
| ) |  |

Sets the rotation and scale components of the transform, leaving translation untouched.

This, or set_pos_hpr_scale, is the preferred way to update a transform when both hpr and scale are to be changed.

setHprScale | ( | float | h,
|  | float | p,
|  | float | r,
|  | float | sx,
|  | float | sy,
|  | float | sz
| ) |  |

Sets the rotation and scale components of the transform, leaving translation untouched.

setInstanceCount | ( | int | instance_count | ) |

Sets the geometry instance count, or 0 if geometry instancing should be disabled.

Do not confuse with instanceTo which only applies to animation instancing.

setLight | ( | NodePath const | light | ) |

Adds the indicated Light or PolylightNode to the list of lights that illuminate geometry at this node and below.

The light itself should be parented into the scene graph elsewhere, to represent the light's position in space; but until set_light() is called it will illuminate no geometry.

setLight | ( | NodePath const | light,
|  | int | priority
| ) |  |

Adds the indicated Light or PolylightNode to the list of lights that illuminate geometry at this node and below.

The light itself should be parented into the scene graph elsewhere, to represent the light's position in space; but until set_light() is called it will illuminate no geometry.

setLightOff | ( | int | priority | ) |

Sets the geometry at this level and below to render using no lights at all.

This is different from not specifying a light; rather, this specifically contradicts set_light() at a higher node level (or, with a priority, overrides a set_light() at a lower level).

If no lights are in effect on a particular piece of geometry, that geometry is rendered with lighting disabled.

setLightOff | ( | NodePath const | light | ) |

Sets the geometry at this level and below to render without using the indicated Light.

This is different from not specifying the Light; rather, this specifically contradicts set_light() at a higher node level (or, with a priority, overrides a set_light() at a lower level).

This interface does not support PolylightNodes, which cannot be turned off at a lower level.

setLightOff | ( | NodePath const | light,
|  | int | priority
| ) |  |

Sets the geometry at this level and below to render without using the indicated Light.

This is different from not specifying the Light; rather, this specifically contradicts set_light() at a higher node level (or, with a priority, overrides a set_light() at a lower level).

This interface does not support PolylightNodes, which cannot be turned off at a lower level.

setLightOff | ( |  | ) |

Sets the geometry at this level and below to render using no lights at all.

This is different from not specifying a light; rather, this specifically contradicts set_light() at a higher node level (or, with a priority, overrides a set_light() at a lower level).

If no lights are in effect on a particular piece of geometry, that geometry is rendered with lighting disabled.

setMat | ( | Mat4 const | mat | ) |

Directly sets an arbitrary 4x4 transform matrix.

setMat | ( | NodePath const | other,
|  | Mat4 const | mat
| ) |  |

Converts the indicated matrix from the other's coordinate space to the local coordinate space, and applies it to the node.

setMaterial | ( | Material | tex | ) |

Sets the geometry at this level and below to render using the indicated material.

Previously, this operation made a copy of the material structure, but nowadays it assigns the pointer directly.

setMaterial | ( | Material | tex,
|  | int | priority
| ) |  |

Sets the geometry at this level and below to render using the indicated material.

Previously, this operation made a copy of the material structure, but nowadays it assigns the pointer directly.

setMaterialOff | ( | int | priority | ) |

Sets the geometry at this level and below to render using no material.

This is normally the default, but it may be useful to use this to contradict set_material() at a higher node level (or, with a priority, to override a set_material() at a lower level).

setMaterialOff | ( |  | ) |

Sets the geometry at this level and below to render using no material.

This is normally the default, but it may be useful to use this to contradict set_material() at a higher node level (or, with a priority, to override a set_material() at a lower level).

static setMaxSearchDepth | ( | int | max_search_depth | ) | `[static]`

Certain operations, such as find() or find_all_matches(), require a traversal of the scene graph to search for the target node or nodes.

This traversal does not attempt to detect cycles, so an arbitrary cap is set on the depth of the traversal as a poor man's cycle detection, in the event that a cycle has inadvertently been introduced into the scene graph.

There may be other reasons you'd want to truncate a search before the bottom of the scene graph has been reached. In any event, this function sets the limit on the number of levels that a traversal will continue, and hence the maximum length of a path that may be returned by a traversal.

This is a static method, and so changing this parameter affects all of the NodePaths in the universe.

setName | ( | string | name | ) |

Changes the name of the referenced node.

setNormalMap | ( | Texture | normal_map | ) |

A convenience function to set up a normal map on this geometry.

This uses the single highest-priority light on the object only. It also requires multitexture, and consumes at least two texture stages, in addition to what may already be in use.

The normal_map parameter is the texture that contains the normal map information (with a 3-d delta vector encoded into the r,g,b of each texel). texcoord_name is the name of the texture coordinate set that contains the tangent and binormal we wish to use. If preserve_color is true, then one additional texture stage is consumed to blend in the geometry's original vertex color.

Only one normal map may be in effect through this interface at any given time.

setNormalMap | ( | Texture | normal_map,
|  | string | texcoord_name
| ) |  |

A convenience function to set up a normal map on this geometry.

This uses the single highest-priority light on the object only. It also requires multitexture, and consumes at least two texture stages, in addition to what may already be in use.

The normal_map parameter is the texture that contains the normal map information (with a 3-d delta vector encoded into the r,g,b of each texel). texcoord_name is the name of the texture coordinate set that contains the tangent and binormal we wish to use. If preserve_color is true, then one additional texture stage is consumed to blend in the geometry's original vertex color.

Only one normal map may be in effect through this interface at any given time.

setNormalMap | ( | Texture | normal_map,
|  | string | texcoord_name,
|  | bool | preserve_color
| ) |  |

A convenience function to set up a normal map on this geometry.

This uses the single highest-priority light on the object only. It also requires multitexture, and consumes at least two texture stages, in addition to what may already be in use.

The normal_map parameter is the texture that contains the normal map information (with a 3-d delta vector encoded into the r,g,b of each texel). texcoord_name is the name of the texture coordinate set that contains the tangent and binormal we wish to use. If preserve_color is true, then one additional texture stage is consumed to blend in the geometry's original vertex color.

Only one normal map may be in effect through this interface at any given time.

setOccluder | ( | NodePath const | occluder | ) |

Adds the indicated occluder to the list of occluders that apply to geometry at this node and below.

The occluder itself, an OccluderNode, should be parented into the scene graph elsewhere, to represent the occluder's position in space; but until set_occluder() is called it will clip no geometry.

setP | ( | float | p | ) |

setP | ( | NodePath const | other,
|  | float | p
| ) |  |

setPos | ( | NodePath const | other,
|  | VBase3 const | pos
| ) |  |

Sets the translation component of the transform, relative to the other node.

setPos | ( | NodePath const | other,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

Sets the translation component of the transform, relative to the other node.

setPos | ( | VBase3 const | pos | ) |

Sets the translation component of the transform, leaving rotation and scale untouched.

This also resets the node's "previous" position, so that the collision system will see the node as having suddenly appeared in the new position, without passing any points in between. See Also: NodePath.set_fluid_pos

setPos | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |

Sets the translation component of the transform, leaving rotation and scale untouched.

This also resets the node's "previous" position, so that the collision system will see the node as having suddenly appeared in the new position, without passing any points in between.

setPosHpr | ( | VBase3 const | pos,
|  | VBase3 const | hpr
| ) |  |

Sets the translation and rotation component of the transform, leaving scale untouched.

setPosHpr | ( | NodePath const | other,
|  | VBase3 const | pos,
|  | VBase3 const | hpr
| ) |  |

Sets the translation and rotation component of the transform, relative to the other node.

setPosHpr | ( | NodePath const | other,
|  | float | x,
|  | float | y,
|  | float | z,
|  | float | h,
|  | float | p,
|  | float | r
| ) |  |

Sets the translation and rotation component of the transform, relative to the other node.

setPosHpr | ( | float | x,
|  | float | y,
|  | float | z,
|  | float | h,
|  | float | p,
|  | float | r
| ) |  |

Sets the translation and rotation component of the transform, leaving scale untouched.

setPosHprScale | ( | VBase3 const | pos,
|  | VBase3 const | hpr,
|  | VBase3 const | scale
| ) |  |

Replaces the translation, rotation, and scale components, implicitly setting shear to 0.

setPosHprScale | ( | NodePath const | other,
|  | VBase3 const | pos,
|  | VBase3 const | hpr,
|  | VBase3 const | scale
| ) |  |

Completely replaces the transform with new translation, rotation, and scale components, relative to the other node, implicitly setting shear to 0.

setPosHprScale | ( | NodePath const | other,
|  | float | x,
|  | float | y,
|  | float | z,
|  | float | h,
|  | float | p,
|  | float | r,
|  | float | sx,
|  | float | sy,
|  | float | sz
| ) |  |

Completely replaces the transform with new translation, rotation, and scale components, relative to the other node.

setPosHprScale | ( | float | x,
|  | float | y,
|  | float | z,
|  | float | h,
|  | float | p,
|  | float | r,
|  | float | sx,
|  | float | sy,
|  | float | sz
| ) |  |

Completely replaces the transform with new translation, rotation, and scale components.

setPosHprScaleShear | ( | VBase3 const | pos,
|  | VBase3 const | hpr,
|  | VBase3 const | scale,
|  | VBase3 const | shear
| ) |  |

Completely replaces the transform with new translation, rotation, scale, and shear components.

setPosHprScaleShear | ( | NodePath const | other,
|  | VBase3 const | pos,
|  | VBase3 const | hpr,
|  | VBase3 const | scale,
|  | VBase3 const | shear
| ) |  |

Completely replaces the transform with new translation, rotation, scale, and shear components, relative to the other node.

setPosQuat | ( | VBase3 const | pos,
|  | Quat const | quat
| ) |  |

Sets the translation and rotation component of the transform, leaving scale untouched.

setPosQuat | ( | NodePath const | other,
|  | VBase3 const | pos,
|  | Quat const | quat
| ) |  |

Sets the translation and rotation component of the transform, relative to the other node.

setPosQuatScale | ( | NodePath const | other,
|  | VBase3 const | pos,
|  | Quat const | quat,
|  | VBase3 const | scale
| ) |  |

Completely replaces the transform with new translation, rotation, and scale components, relative to the other node, implicitly setting shear to 0.

setPosQuatScale | ( | VBase3 const | pos,
|  | Quat const | quat,
|  | VBase3 const | scale
| ) |  |

Replaces the translation, rotation, and scale components, implicitly setting shear to 0.

setPosQuatScaleShear | ( | NodePath const | other,
|  | VBase3 const | pos,
|  | Quat const | quat,
|  | VBase3 const | scale,
|  | VBase3 const | shear
| ) |  |

Completely replaces the transform with new translation, rotation, scale, and shear components, relative to the other node.

setPosQuatScaleShear | ( | VBase3 const | pos,
|  | Quat const | quat,
|  | VBase3 const | scale,
|  | VBase3 const | shear
| ) |  |

Completely replaces the transform with new translation, rotation, scale, and shear components.

setPrevTransform | ( | NodePath const | other,
|  | TransformState const | transform,
|  | Thread | current_thread
| ) |  |

Sets the "previous" transform object on this node, relative to the other node.

This computes a new transform object that will have the indicated value when seen from the other node.

setPrevTransform | ( | NodePath const | other,
|  | TransformState const | transform
| ) |  |

Sets the "previous" transform object on this node, relative to the other node.

This computes a new transform object that will have the indicated value when seen from the other node.

setPrevTransform | ( | TransformState const | transform | ) |

Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.

setPrevTransform | ( | TransformState const | transform,
|  | Thread | current_thread
| ) |  |

Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.

setPythonTag | ( | string | key,
|  | PyObject | value
| ) |  |

Associates an arbitrary Python object with a user-defined key which is stored on the node.

This object has no meaning to Panda; but it is stored indefinitely on the node until it is requested again.

Each unique key stores a different Python object. There is no effective limit on the number of different keys that may be stored or on the nature of any one key's object.

setQuat | ( | Quat const | quat | ) |

Sets the rotation component of the transform, leaving translation and scale untouched.

setQuat | ( | NodePath const | other,
|  | Quat const | quat
| ) |  |

Sets the rotation component of the transform, relative to the other node.

setQuatScale | ( | NodePath const | other,
|  | Quat const | quat,
|  | VBase3 const | scale
| ) |  |

Sets the rotation and scale components of the transform, leaving translation untouched.

This, or set_pos_quat_scale, is the preferred way to update a transform when both quat and scale are to be changed.

setQuatScale | ( | Quat const | quat,
|  | VBase3 const | scale
| ) |  |

Sets the rotation and scale components of the transform, leaving translation untouched.

setR | ( | NodePath const | other,
|  | float | r
| ) |  |

setR | ( | float | r | ) |

setRenderMode | ( | Mode | mode,
|  | float | thickness
| ) |  |

Sets up the geometry at this level and below (unless overridden) to render in the specified mode and with the indicated line and/or point thickness.

setRenderMode | ( | Mode | mode,
|  | float | thickness,
|  | int | priority
| ) |  |

Sets up the geometry at this level and below (unless overridden) to render in the specified mode and with the indicated line and/or point thickness.

setRenderModeFilled | ( |  | ) |

Sets up the geometry at this level and below (unless overridden) to render in filled (i.e.

not wireframe) mode.

setRenderModeFilled | ( | int | priority | ) |

Sets up the geometry at this level and below (unless overridden) to render in filled (i.e.

not wireframe) mode.

setRenderModePerspective | ( | bool | perspective,
|  | int | priority
| ) |  |

Sets up the point geometry at this level and below to render as perspective sprites (that is, billboarded quads).

The thickness, as specified with set_render_mode_thickness(), is the width of each point in 3-D units, unless it is overridden on a per-vertex basis. This does not affect geometry other than points.

If you want the quads to be individually textured, you should also set a TexGenAttrib.M_point_sprite on the node.

setRenderModePerspective | ( | bool | perspective | ) |

Sets up the point geometry at this level and below to render as perspective sprites (that is, billboarded quads).

The thickness, as specified with set_render_mode_thickness(), is the width of each point in 3-D units, unless it is overridden on a per-vertex basis. This does not affect geometry other than points.

If you want the quads to be individually textured, you should also set a TexGenAttrib.M_point_sprite on the node.

setRenderModeThickness | ( | float | thickness,
|  | int | priority
| ) |  |

Sets up the point geometry at this level and below to render as thick points (that is, billboarded quads).

The thickness is in pixels, unless set_render_mode_perspective is also true, in which case it is in 3-D units.

If you want the quads to be individually textured, you should also set a TexGenAttrib.M_point_sprite on the node.

setRenderModeThickness | ( | float | thickness | ) |

Sets up the point geometry at this level and below to render as thick points (that is, billboarded quads).

The thickness is in pixels, unless set_render_mode_perspective is also true, in which case it is in 3-D units.

If you want the quads to be individually textured, you should also set a TexGenAttrib.M_point_sprite on the node.

setRenderModeWireframe | ( |  | ) |

Sets up the geometry at this level and below (unless overridden) to render in wireframe mode.

setRenderModeWireframe | ( | int | priority | ) |

Sets up the geometry at this level and below (unless overridden) to render in wireframe mode.

setSa | ( | float | sa | ) |

Sets the alpha scale component of the transform.

setSb | ( | float | sb | ) |

Sets the blue scale component of the transform.

setScale | ( | VBase3 const | scale | ) |

Sets the scale component of the transform, leaving translation and rotation untouched.

setScale | ( | NodePath const | other,
|  | VBase3 const | scale
| ) |  |

Sets the scale component of the transform, relative to the other node.

setScale | ( | NodePath const | other,
|  | float | scale
| ) |  |

Sets the scale component of the transform, relative to the other node.

setScale | ( | NodePath const | other,
|  | float | sx,
|  | float | sy,
|  | float | sz
| ) |  |

Sets the scale component of the transform, relative to the other node.

setScale | ( | float | scale | ) |

Sets the scale component of the transform, leaving translation and rotation untouched.

setScale | ( | float | sx,
|  | float | sy,
|  | float | sz
| ) |  |

setScissor | ( | Point3 const | a,
|  | Point3 const | b,
|  | Point3 const | c,
|  | Point3 const | d
| ) |  |

Sets up a scissor region on the nodes rendered at this level and below.

The four points are understood to be relative to this node. When these points are projected into screen space, they define the bounding volume of the scissor region (the scissor region is the smallest onscreen rectangle that encloses all four points).

setScissor | ( | NodePath const | other,
|  | Point3 const | a,
|  | Point3 const | b,
|  | Point3 const | c,
|  | Point3 const | d
| ) |  |

Sets up a scissor region on the nodes rendered at this level and below.

The four points are understood to be relative to the indicated other node. When these points are projected into screen space, they define the bounding volume of the scissor region (the scissor region is the smallest onscreen rectangle that encloses all four points).

setScissor | ( | float | left,
|  | float | right,
|  | float | bottom,
|  | float | top
| ) |  |

Sets up a scissor region on the nodes rendered at this level and below.

The four coordinates are understood to define a rectangle in screen space. These numbers are relative to the current DisplayRegion, where (0,0) is the lower-left corner of the DisplayRegion, and (1,1) is the upper-right corner.

setScissor | ( | NodePath const | other,
|  | Point3 const | a,
|  | Point3 const | b
| ) |  |

Sets up a scissor region on the nodes rendered at this level and below.

The two points are understood to be relative to the indicated other node. When these points are projected into screen space, they define the diagonally-opposite points that determine the scissor region.

setScissor | ( | Point3 const | a,
|  | Point3 const | b
| ) |  |

Sets up a scissor region on the nodes rendered at this level and below.

The two points are understood to be relative to this node. When these points are projected into screen space, they define the diagonally-opposite points that determine the scissor region.

setSg | ( | float | sg | ) |

Sets the alpha scale component of the transform.

setShader | ( | Shader const | sha,
|  | int | priority
| ) |  |

setShader | ( | Shader const | sha | ) |

setShaderAuto | ( | int | priority | ) |

setShaderAuto | ( | BitMaskunsigned | int,
|  | 32 | shader_switch,
|  | int | priority
| ) |  |

overloaded for auto shader customization

setShaderAuto | ( | BitMaskunsigned | int,
|  | 32 | shader_switch
| ) |  |

overloaded for auto shader customization

setShaderAuto | ( |  | ) |

setShaderInput | ( | InternalName const | id,
|  | double | n1,
|  | double | n2,
|  | double | n3,
|  | double | n4,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | VBase4 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayVBase2 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | NodePath const | np
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayUnalignedLVecBase4f const | v
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | double | n1,
|  | double | n2,
|  | double | n3,
|  | double | n4
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayfloat const | v
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayMat3 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArraydouble const | v
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayVBase3 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayVBase2 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArraydouble const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | string | id,
|  | double | n1,
|  | double | n2,
|  | double | n3
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayUnalignedLVecBase4f const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | string | id,
|  | Mat3 const | v
| ) |  |

setShaderInput | ( | string | id | ) |

setShaderInput | ( | string | id,
|  | VBase2 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayUnalignedLVecBase4f const | v
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayfloat const | v
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayfloat const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | VBase2 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | VBase4 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | string | id,
|  | double | n1
| ) |  |

setShaderInput | ( | string | id,
|  | VBase4 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | VBase3 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayVBase2 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayUnalignedLVecBase4f const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayVBase3 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | VBase2 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayfloat const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | VBase2 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayUnalignedLMatrix4f const | v
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayVBase3 const | v
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | NodePath const | np,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | VBase3 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayVBase2 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayVBase3 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayUnalignedLMatrix4f const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id | ) |

setShaderInput | ( | InternalName const | id,
|  | PointerToArraydouble const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | Texture | tex,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | VBase4 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | double | n1,
|  | double | n2,
|  | double | n3
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | double | n1
| ) |  |

setShaderInput | ( | ShaderInput const | inp | ) |

setShaderInput | ( | InternalName const | id,
|  | Texture | tex
| ) |  |

setShaderInput | ( | string | id,
|  | Mat4 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | VBase3 const | v
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | Mat3 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | Mat4 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | NodePath const | np
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayMat3 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayMat3 const | v
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | Mat3 const | v
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | double | n1,
|  | double | n2
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayUnalignedLMatrix4f const | v
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArraydouble const | v
| ) |  |

setShaderInput | ( | string | id,
|  | Texture | tex
| ) |  |

setShaderInput | ( | string | id,
|  | double | n1,
|  | double | n2,
|  | double | n3,
|  | double | n4,
|  | int | priority
| ) |  |

setShaderInput | ( | string | id,
|  | double | n1,
|  | double | n2,
|  | double | n3,
|  | double | n4
| ) |  |

setShaderInput | ( | string | id,
|  | double | n1,
|  | double | n2
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | PointerToArrayMat3 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | Mat4 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | string | id,
|  | Mat3 const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | string | id,
|  | Texture | tex,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | VBase3 const | v
| ) |  |

setShaderInput | ( | string | id,
|  | NodePath const | np,
|  | int | priority
| ) |  |

setShaderInput | ( | string | id,
|  | PointerToArrayUnalignedLMatrix4f const | v,
|  | int | priority
| ) |  |

setShaderInput | ( | InternalName const | id,
|  | Mat4 const | v,
|  | int | priority
| ) |  |

setShaderOff | ( |  | ) |

setShaderOff | ( | int | priority | ) |

setShear | ( | float | shxy,
|  | float | shxz,
|  | float | shyz
| ) |  |

Sets the shear component of the transform, leaving translation, rotation, and scale untouched.

setShear | ( | NodePath const | other,
|  | VBase3 const | shear
| ) |  |

Sets the shear component of the transform, relative to the other node.

setShear | ( | NodePath const | other,
|  | float | shxy,
|  | float | shxz,
|  | float | shyz
| ) |  |

Sets the shear component of the transform, relative to the other node.

setShear | ( | VBase3 const | shear | ) |

Sets the shear component of the transform, leaving translation and rotation untouched.

setShxy | ( | float | shxy | ) |

setShxy | ( | NodePath const | other,
|  | float | shxy
| ) |  |

setShxz | ( | float | shxz | ) |

setShxz | ( | NodePath const | other,
|  | float | shxz
| ) |  |

setShyz | ( | NodePath const | other,
|  | float | shyz
| ) |  |

setShyz | ( | float | shyz | ) |

setSr | ( | float | sr | ) |

Sets the red scale component of the transform.

setState | ( | RenderState const | state | ) |

Changes the complete state object on this node.

setState | ( | RenderState const | state,
|  | Thread | current_thread
| ) |  |

Changes the complete state object on this node.

setState | ( | NodePath const | other,
|  | RenderState const | state,
|  | Thread | current_thread
| ) |  |

Sets the state object on this node, relative to the other node.

This computes a new state object that will have the indicated value when seen from the other node.

setState | ( | NodePath const | other,
|  | RenderState const | state
| ) |  |

Sets the state object on this node, relative to the other node.

This computes a new state object that will have the indicated value when seen from the other node.

setSx | ( | NodePath const | other,
|  | float | sx
| ) |  |

setSx | ( | float | sx | ) |

setSy | ( | float | sy | ) |

setSy | ( | NodePath const | other,
|  | float | sy
| ) |  |

setSz | ( | float | sz | ) |

setSz | ( | NodePath const | other,
|  | float | sz
| ) |  |

setTag | ( | string | key,
|  | string | value
| ) |  |

Associates a user-defined value with a user-defined key which is stored on the node.

This value has no meaning to Panda; but it is stored indefinitely on the node until it is requested again.

Each unique key stores a different string value. There is no effective limit on the number of different keys that may be stored or on the length of any one key's value.

setTexGen | ( | TextureStage | stage,
|  | TexGenMode | mode,
|  | int | priority
| ) |  |

Enables automatic texture coordinate generation for the indicated texture stage.

setTexGen | ( | TextureStage | stage,
|  | TexGenMode | mode,
|  | Point3 const | constant_value,
|  | int | priority
| ) |  |

Enables automatic texture coordinate generation for the indicated texture stage.

This version of this method is useful when setting M_constant, which requires a constant texture coordinate value.

setTexGen | ( | TextureStage | stage,
|  | TexGenMode | mode,
|  | string | source_name,
|  | NodePath const | light,
|  | int | priority
| ) |  |

Enables automatic texture coordinate generation for the indicated texture stage.

This version of this method is useful when setting M_light_vector, which requires the name of the texture coordinate set that supplies the tangent and binormal, as well as the specific light to generate coordinates for.

setTexGen | ( | TextureStage | stage,
|  | TexGenMode | mode,
|  | Point3 const | constant_value
| ) |  |

Enables automatic texture coordinate generation for the indicated texture stage.

This version of this method is useful when setting M_constant, which requires a constant texture coordinate value.

setTexGen | ( | TextureStage | stage,
|  | TexGenMode | mode,
|  | string | source_name,
|  | NodePath const | light
| ) |  |

Enables automatic texture coordinate generation for the indicated texture stage.

This version of this method is useful when setting M_light_vector, which requires the name of the texture coordinate set that supplies the tangent and binormal, as well as the specific light to generate coordinates for.

setTexGen | ( | TextureStage | stage,
|  | TexGenMode | mode
| ) |  |

Enables automatic texture coordinate generation for the indicated texture stage.

setTexHpr | ( | NodePath const | other,
|  | TextureStage | stage,
|  | VBase3 const | hpr
| ) |  |

Sets a texture matrix on the current node to apply the indicated rotation, as a 3-D HPR, to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexHpr | ( | TextureStage | stage,
|  | float | h,
|  | float | p,
|  | float | r
| ) |  |

Sets a texture matrix on the current node to apply the indicated rotation, as a 3-D HPR, to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexHpr | ( | TextureStage | stage,
|  | VBase3 const | hpr
| ) |  |

Sets a texture matrix on the current node to apply the indicated rotation, as a 3-D HPR, to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexHpr | ( | NodePath const | other,
|  | TextureStage | stage,
|  | float | h,
|  | float | p,
|  | float | r
| ) |  |

Sets a texture matrix on the current node to apply the indicated rotation, as a 3-D HPR, to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexOffset | ( | NodePath const | other,
|  | TextureStage | stage,
|  | float | u,
|  | float | v
| ) |  |

Sets a texture matrix on the current node to apply the indicated offset to UV's for the given stage.

This call is appropriate for ordinary 2-d texture coordinates.

setTexOffset | ( | TextureStage | stage,
|  | VBase2 const | uv
| ) |  |

Sets a texture matrix on the current node to apply the indicated offset to UV's for the given stage.

This call is appropriate for ordinary 2-d texture coordinates.

setTexOffset | ( | TextureStage | stage,
|  | float | u,
|  | float | v
| ) |  |

Sets a texture matrix on the current node to apply the indicated offset to UV's for the given stage.

This call is appropriate for ordinary 2-d texture coordinates.

setTexOffset | ( | NodePath const | other,
|  | TextureStage | stage,
|  | VBase2 const | uv
| ) |  |

Sets a texture matrix on the current node to apply the indicated offset to UV's for the given stage.

This call is appropriate for ordinary 2-d texture coordinates.

setTexPos | ( | TextureStage | stage,
|  | float | u,
|  | float | v,
|  | float | w
| ) |  |

Sets a texture matrix on the current node to apply the indicated offset to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexPos | ( | NodePath const | other,
|  | TextureStage | stage,
|  | VBase3 const | uvw
| ) |  |

Sets a texture matrix on the current node to apply the indicated offset to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexPos | ( | NodePath const | other,
|  | TextureStage | stage,
|  | float | u,
|  | float | v,
|  | float | w
| ) |  |

Sets a texture matrix on the current node to apply the indicated offset to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexPos | ( | TextureStage | stage,
|  | VBase3 const | uvw
| ) |  |

Sets a texture matrix on the current node to apply the indicated offset to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexProjector | ( | TextureStage | stage,
|  | NodePath const | from,
|  | NodePath const | to
| ) |  |

Establishes a TexProjectorEffect on this node, which can be used to establish projective texturing (but see also the NodePath.project_texture() convenience function), or it can be used to bind this node's texture transform to particular node's position in space, allowing a LerpInterval (for instance) to adjust this node's texture coordinates.

setTexRotate | ( | TextureStage | stage,
|  | float | r
| ) |  |

Sets a texture matrix on the current node to apply the indicated rotation, clockwise in degrees, to UV's for the given stage.

This call is appropriate for ordinary 2-d texture coordinates.

setTexRotate | ( | NodePath const | other,
|  | TextureStage | stage,
|  | float | r
| ) |  |

Sets a texture matrix on the current node to apply the indicated rotation, clockwise in degrees, to UV's for the given stage.

This call is appropriate for ordinary 2-d texture coordinates.

setTexScale | ( | NodePath const | other,
|  | TextureStage | stage,
|  | float | su,
|  | float | sv,
|  | float | sw
| ) |  |

Sets a texture matrix on the current node to apply the indicated scale to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexScale | ( | NodePath const | other,
|  | TextureStage | stage,
|  | float | scale
| ) |  |

Sets a texture matrix on the current node to apply the indicated scale to UV's for the given stage.

This call is appropriate for 2-d or 3-d texture coordinates.

setTexScale | ( | TextureStage | stage,
|  | float | scale
| ) |  |

Sets a texture matrix on the current node to apply the indicated scale to UVW's for the given stage.

This call is appropriate for 2-d or 3-d texture coordinates.

setTexScale | ( | TextureStage | stage,
|  | VBase3 const | scale
| ) |  |

Sets a texture matrix on the current node to apply the indicated scale to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexScale | ( | NodePath const | other,
|  | TextureStage | stage,
|  | VBase3 const | scale
| ) |  |

Sets a texture matrix on the current node to apply the indicated scale to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexScale | ( | TextureStage | stage,
|  | float | su,
|  | float | sv
| ) |  |

Sets a texture matrix on the current node to apply the indicated scale to UV's for the given stage.

This call is appropriate for ordinary 2-d texture coordinates.

setTexScale | ( | TextureStage | stage,
|  | VBase2 const | scale
| ) |  |

Sets a texture matrix on the current node to apply the indicated scale to UV's for the given stage.

This call is appropriate for ordinary 2-d texture coordinates.

setTexScale | ( | TextureStage | stage,
|  | float | su,
|  | float | sv,
|  | float | sw
| ) |  |

Sets a texture matrix on the current node to apply the indicated scale to UVW's for the given stage.

This call is appropriate for 3-d texture coordinates.

setTexScale | ( | NodePath const | other,
|  | TextureStage | stage,
|  | VBase2 const | scale
| ) |  |

Sets a texture matrix on the current node to apply the indicated scale to UV's for the given stage.

This call is appropriate for ordinary 2-d texture coordinates.

setTexScale | ( | NodePath const | other,
|  | TextureStage | stage,
|  | float | su,
|  | float | sv
| ) |  |

Sets a texture matrix on the current node to apply the indicated scale to UV's for the given stage.

This call is appropriate for ordinary 2-d texture coordinates.

setTexTransform | ( | NodePath const | other,
|  | TextureStage | stage,
|  | TransformState const | transform
| ) |  |

Sets the texture matrix on the current node to the indicated transform for the given stage.

setTexTransform | ( | TextureStage | stage,
|  | TransformState const | transform
| ) |  |

Sets the texture matrix on the current node to the indicated transform for the given stage.

setTexture | ( | TextureStage | stage,
|  | Texture | tex
| ) |  |

Adds the indicated texture to the list of textures that will be rendered on the indicated multitexture stage.

If there are multiple texture stages specified (possibly on multiple different nodes at different levels), they will all be applied to geometry together, according to the stage specification set up in the TextureStage object.

setTexture | ( | Texture | tex | ) |

Adds the indicated texture to the list of textures that will be rendered on the default texture stage.

This is the convenience single-texture variant of this method; it is now superceded by set_texture() that accepts a stage and texture. You may use this method if you just want to adjust the default stage.

setTexture | ( | Texture | tex,
|  | int | priority
| ) |  |

Adds the indicated texture to the list of textures that will be rendered on the default texture stage.

This is the convenience single-texture variant of this method; it is now superceded by set_texture() that accepts a stage and texture. You may use this method if you just want to adjust the default stage.

setTexture | ( | TextureStage | stage,
|  | Texture | tex,
|  | int | priority
| ) |  |

Adds the indicated texture to the list of textures that will be rendered on the indicated multitexture stage.

If there are multiple texture stages specified (possibly on multiple different nodes at different levels), they will all be applied to geometry together, according to the stage specification set up in the TextureStage object.

setTextureOff | ( | int | priority | ) |

Sets the geometry at this level and below to render using no texture, on any stage.

This is different from not specifying a texture; rather, this specifically contradicts set_texture() at a higher node level (or, with a priority, overrides a set_texture() at a lower level).

setTextureOff | ( |  | ) |

Sets the geometry at this level and below to render using no texture, on any stage.

This is different from not specifying a texture; rather, this specifically contradicts set_texture() at a higher node level (or, with a priority, overrides a set_texture() at a lower level).

setTextureOff | ( | TextureStage | stage,
|  | int | priority
| ) |  |

Sets the geometry at this level and below to render using no texture, on the indicated stage.

This is different from not specifying a texture; rather, this specifically contradicts set_texture() at a higher node level (or, with a priority, overrides a set_texture() at a lower level).

setTextureOff | ( | TextureStage | stage | ) |

Sets the geometry at this level and below to render using no texture, on the indicated stage.

This is different from not specifying a texture; rather, this specifically contradicts set_texture() at a higher node level (or, with a priority, overrides a set_texture() at a lower level).

setTransform | ( | TransformState const | transform | ) |

Changes the complete transform object on this node.

setTransform | ( | NodePath const | other,
|  | TransformState const | transform,
|  | Thread | current_thread
| ) |  |

Sets the transform object on this node, relative to the other node.

This computes a new transform object that will have the indicated value when seen from the other node.

setTransform | ( | NodePath const | other,
|  | TransformState const | transform
| ) |  |

Sets the transform object on this node, relative to the other node.

This computes a new transform object that will have the indicated value when seen from the other node.

setTransform | ( | TransformState const | transform,
|  | Thread | current_thread
| ) |  |

Changes the complete transform object on this node.

setTransparency | ( | Mode | mode,
|  | int | priority
| ) |  |

Specifically sets or disables transparent rendering mode on this particular node.

If no other nodes override, this will cause items with a non-1 value for alpha color to be rendered partially transparent.

setTransparency | ( | Mode | mode | ) |

Specifically sets or disables transparent rendering mode on this particular node.

If no other nodes override, this will cause items with a non-1 value for alpha color to be rendered partially transparent.

setTwoSided | ( | bool | two_sided,
|  | int | priority
| ) |  |

Specifically sets or disables two-sided rendering mode on this particular node.

If no other nodes override, this will cause backfacing polygons to be drawn (in two-sided mode, true) or culled (in one-sided mode, false).

setTwoSided | ( | bool | two_sided | ) |

Specifically sets or disables two-sided rendering mode on this particular node.

If no other nodes override, this will cause backfacing polygons to be drawn (in two-sided mode, true) or culled (in one-sided mode, false).

setX | ( | float | x | ) |

setX | ( | NodePath const | other,
|  | float | x
| ) |  |

setY | ( | NodePath const | other,
|  | float | y
| ) |  |

setY | ( | float | y | ) |

setZ | ( | NodePath const | other,
|  | float | z
| ) |  |

setZ | ( | float | z | ) |

show | ( |  | ) |

Undoes the effect of a previous hide() on this node: makes the referenced node (and the entire subgraph below this node) visible to all cameras.

This will not reveal the node if a parent node has been hidden.

show | ( | BitMaskunsigned | int,
|  | 32 | camera_mask
| ) |  |

Makes the referenced node visible just to the cameras whose camera_mask shares the indicated bits.

This undoes the effect of a previous hide() call. It will not reveal the node if a parent node has been hidden. However, see show_through().

showBounds | ( |  | ) |

Causes the bounding volume of the bottom node and all of its descendants (that is, the bounding volume associated with the the bottom arc) to be rendered, if possible.

The rendering method is less than optimal; this is intended primarily for debugging.

showThrough | ( | BitMaskunsigned | int,
|  | 32 | camera_mask
| ) |  |

Makes the referenced node visible just to the cameras whose camera_mask shares the indicated bits.

Unlike show(), this will reveal the node even if a parent node has been hidden via the one-parameter hide() method, thus "showing through" a parent's hide(). (However, it will not show through a parent's hide() call if the no-parameter form of hide() was used.)

showThrough | ( |  | ) |

Makes the referenced node visible just to the cameras whose camera_mask shares the indicated bits.

Unlike show(), this will reveal the node even if a parent node has been hidden, thus "showing through" a parent's hide().

showTightBounds | ( |  | ) |

Similar to show_bounds(), this draws a bounding box representing the "tight" bounds of this node and all of its descendants.

The bounding box is recomputed every frame by reexamining all of the vertices; this is far from efficient, but this is intended for debugging.

stash | ( | int | sort,
|  | Thread | current_thread
| ) |  |

Removes the referenced node (and the entire subgraph below this node) from the scene graph in any normal sense.

The node will no longer be visible and is not tested for collisions; furthermore, no normal scene graph traversal will visit the node. The node's bounding volume no longer contributes to its parent's bounding volume.

A stashed node cannot be located by a normal find() operation (although a special find string can still retrieve it).

stash | ( |  | ) |

Removes the referenced node (and the entire subgraph below this node) from the scene graph in any normal sense.

The node will no longer be visible and is not tested for collisions; furthermore, no normal scene graph traversal will visit the node. The node's bounding volume no longer contributes to its parent's bounding volume.

A stashed node cannot be located by a normal find() operation (although a special find string can still retrieve it).

stash | ( | int | sort | ) |

Removes the referenced node (and the entire subgraph below this node) from the scene graph in any normal sense.

The node will no longer be visible and is not tested for collisions; furthermore, no normal scene graph traversal will visit the node. The node's bounding volume no longer contributes to its parent's bounding volume.

A stashed node cannot be located by a normal find() operation (although a special find string can still retrieve it).

stashTo | ( | NodePath const | other | ) |

Similar to reparent_to(), but the node is added to its new parent's stashed list, so that the result is equivalent to calling reparent_to() immediately followed by stash().

stashTo | ( | NodePath const | other,
|  | int | sort,
|  | Thread | current_thread
| ) |  |

Similar to reparent_to(), but the node is added to its new parent's stashed list, so that the result is equivalent to calling reparent_to() immediately followed by stash().

stashTo | ( | NodePath const | other,
|  | int | sort
| ) |  |

Similar to reparent_to(), but the node is added to its new parent's stashed list, so that the result is equivalent to calling reparent_to() immediately followed by stash().

unifyTextureStages | ( | TextureStage | stage | ) |

Searches through all TextureStages at this node and below.

Any TextureStages that share the same name as the indicated TextureStage object are replaced with this object, thus ensuring that all geometry at this node and below with a particular TextureStage name is using the same TextureStage object.

unstash | ( | int | sort | ) |

Undoes the effect of a previous stash() on this node: makes the referenced node (and the entire subgraph below this node) once again part of the scene graph.

unstash | ( | int | sort,
|  | Thread | current_thread
| ) |  |

Undoes the effect of a previous stash() on this node: makes the referenced node (and the entire subgraph below this node) once again part of the scene graph.

unstash | ( |  | ) |

Undoes the effect of a previous stash() on this node: makes the referenced node (and the entire subgraph below this node) once again part of the scene graph.

unstashAll | ( | Thread | current_thread | ) |

Unstashes this node and all stashed child nodes.

unstashAll | ( |  | ) |

Unstashes this node and all stashed child nodes.

bool verifyComplete | ( | Thread | current_thread | ) |

Returns true if all of the nodes described in the NodePath are connected, or false otherwise.

bool verifyComplete | ( |  | ) |

Returns true if all of the nodes described in the NodePath are connected, or false otherwise.

bool writeBamFile | ( | Filename const | filename | ) |

Writes the contents of this node and below out to a bam file with the indicated filename.

This file may then be read in again, as is, at some later point. Returns true if successful, false on some kind of error.

bool writeBamStream | ( | ostream | out | ) |

Writes the contents of this node and below out to the indicated stream.

writeBounds | ( | ostream | out | ) |

Writes a description of the bounding volume containing the bottom node and all of its descendants to the indicated output stream.

wrtReparentTo | ( | NodePath const | other | ) |

This functions identically to reparent_to(), except the transform on this node is also adjusted so that the node remains in the same place in world coordinates, even if it is reparented into a different coordinate system.

wrtReparentTo | ( | NodePath const | other,
|  | int | sort
| ) |  |

This functions identically to reparent_to(), except the transform on this node is also adjusted so that the node remains in the same place in world coordinates, even if it is reparented into a different coordinate system.

wrtReparentTo | ( | NodePath const | other,
|  | int | sort,
|  | Thread | current_thread
| ) |  |

This functions identically to reparent_to(), except the transform on this node is also adjusted so that the node remains in the same place in world coordinates, even if it is reparented into a different coordinate system.

## Member Data Documentation

BitMaskunsigned int

Returns the union of all of the into_collide_masks for nodes at this level and below.

This is the same thing as node()->get_net_collide_mask().

If you want to return what the into_collide_mask of this node itself is, without regard to its children, use node()->get_into_collide_mask().

All Classes Namespaces Functions Variables Enumerations Enumerator Properties